angular.module('longTermRetention',['ngDialog', 'ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','ngGrid','ui.grid.selection', 'ui.grid.edit' ])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])

    .controller('LTRRetentionCtrl', ['$scope', '$rootScope', '$http','ngDialog','$timeout','gettextCatalog', 'uiGridConstants', '$compile',
        function($scope, $rootScope, $http, ngDialog, $timeout, gettextCatalog, uiGridConstants, $compile) {

        $scope.applianceList = [];
        $scope.selected = null;
    // $scope.gridData = [$scope.policyData];
        $scope.gridData = [];
        $scope.selectedItem = null;
        $scope.isDefaultPolicy = false;
        $scope.policyEdit = false;

        // Used to unbind the watched event on dialog close.
        var unbindHandler = null;

        // Used to track any additions or deletions. On close, this will be broadcast to the app as 'policiesModified'.
        var policiesAdded = false;
        var policiesDeleted = false;

        $scope.initCtrl = function(dlg){
            switch (dlg.name) {
                case 'Retention-Policy':
                    processDialog(PHD, window);
                    break;
                case 'Retention-Addition':
                    $scope.policyEdit = false;
                    $scope.processRetentionDialog();
                    break;
                case 'Retention-Edit':
                    $scope.policyEdit = true;
                    $scope.processEditDialog();
                    break;
            }
        };

            $scope.protectPagePolicies = {
                data: 'policyData',
                multiSelect: false,
                enableSelectAll: false,
                selectionRowHeaderWidth: 30,
                rowHeight: 26,
                enableFullRowSelection: true,
                enableFiltering: true,
                enableSorting: true,
                enableColumnResizing: true,
                gridMenuShowHideColumns: true,
                enableColumnMenus: true,
                enableGridMenu: true,
                enableHorizontalScrollbar: 0,
                onRegisterApi: function (gridApi) {
                    $scope.onRegisterGrid(gridApi);
                }

            };


            /*
            * Loops through systems for a policy to see if a default.  On a source appliance, the system list will include the local appliance only.
            * For a target appliance, the system list will consist of the sources for which this policy is associated.
            */
            function checkDefaultPolicy(selectedItem) {
                var defaultPolicy = false;
                var systems = selectedItem.systems;
                for (var i = 0; i < systems.length; i++) {
                    if (systems[i].is_default === true) {
                        defaultPolicy = true;
                        break;
                    }
                }
                return defaultPolicy;
            }

            $scope.getDefaultPolicyStatus = function(row) {
                return row.system.is_default !== undefined  && $scope.policyData.system.is_default !== false ? $scope.policyData.system.is_default : "";
            };

            $scope.copyPagePolicies = {
                data: 'policyData',
                multiSelect: false,
                enableSelectAll: false,
                selectionRowHeaderWidth: 30,
                rowHeight: 26,
                enableFullRowSelection: true,
                enableFiltering: true,
                enableSorting: true,
                enableColumnResizing: true,
                gridMenuShowHideColumns: true,
                enableColumnMenus: true,
                enableGridMenu: true,
                enableHorizontalScrollbar: 0,
                onRegisterApi: function (gridApi) {
                    $scope.onRegisterGrid(gridApi);
                }

            };

            var defaultTemplate = '<div class="ui-grid-cell-contents" style="text-align:center"> ' +
                '<i class="{{grid.appScope.getDefaultIcon(row.entity.systems)}} icon-large"></i>' +
                '</div>';

            $scope.getDefaultIcon = function(systems) {
                var icon = 'icon-checkbox';
                if (systems.length === 0) {
                    icon = 'icon-checkboxalt';
                } else {
                    for (var i = 0; i < systems.length; i++) {
                        if (systems[i].is_default === false) {
                            icon = 'icon-checkboxalt';
                            break;
                        } else if ($scope.copyEdit && systems[i].is_default === true) {
                            icon += " icon-default-policy";
                        }
                    }
                }
                return icon;
            };

            var systemsTemplate = '<div class="ui-grid-cell-contents"> ' +
                '<span ng-show="row.entity.systems.length > 1" style="cursor:pointer" title="Click to view appliance list" ' +
                'ng-click="$event.stopPropagation(); grid.appScope.showSystemsList(row.entity.systems, $event)">' +
                'Multiple' +
                '</span>' +
                '<span ng-show="row.entity.systems.length === 1">' +
                '{{row.entity.systems[0].name}}' +
                '</span>' +
                '</div>';

            $scope.showSystemsList = function(systems, event) {
                var systemList = {'systems': systems};
                var html = systemsTmpl(systemList);
                var $anchor = $(event.target);
                html = $compile(html)($scope);
                $("<div/>").html(html).popover({
                    anchor: $anchor,
                    autoOpen: true,
                    popoverClass: 'job-inventory-result',
                    destroyOnClose: true
                });
            };

            $scope.closeSystemsList = function() {
                $(".job-inventory-result").hide();
            };

            var systemsTmpl = _.template(
                '<p><label class="day-status-day"><span>Available Appliances</span></label></p>' +
                '<% for (var i = 0; i < systems.length; i++) { %>' +
                '<% var system = systems[i]; %>' +
                '<span><%= system.name %></span>' +
                '<br/>' +
                '<% } %>' +
                '<p><a href="" ng-click="closeSystemsList()" ' +
                'class="job-log-link"><i class="icon-list-alt"></i><translate>Close</translate></a></p>'
            );

            $scope.sourcesOnTarget = [];

            // Given the chosen filter (searchTerm), decide which rows should be seen, or removed from view
            function applianceFilterFunction (searchTerm, cellValue) {
                for (var i = 0; i < cellValue.length; i++) {
                    var system_name = cellValue[i].name;
                    var regEx = new RegExp(searchTerm, "i").test(system_name);
                    if (regEx) {
                        return true;
                    }
                }
                return false;
            }

            var applianceColumn =  {
                field: "systems",
                displayName: gettextCatalog.getString("Appliances"),
                headerCellFilter: 'translate',
                cellTemplate: systemsTemplate,
                "filter": {
                    condition: applianceFilterFunction
                },
                visible: true,
                width: 150
            };

            $scope.copyPagePolicies.columnDefs = [
                {
                    field: "id",
                    visible: false
                },
                {
                    field: "systems.is_default",
                    displayName: gettextCatalog.getString("Default Policy"),
                    cellClass: function(grid, row, col) {
                        if (grid.getCellValue(row, col) === true) {
                            return 'icon-default-policy';
                        }
                    },
                    headerCellFilter: 'translate',
                    visible: true,
                    cellTemplate: defaultTemplate,
                    type: 'string',
                    width: 72
                },
                applianceColumn,
                {
                    field: "is_global",
                    displayName: gettextCatalog.getString("Global"),
                    headerCellFilter: 'translate',
                    visible: true,
                    type: 'string',
                    width: 75
                },
                {
                    field: "name",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Policy Name"),
                    cellTooltip: true,
                    visible: true,
                    type: "string"
                },
                {
                    field: "description",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Description"),
                    cellTooltip: true,
                    visible: true,
                    type: "string"
                },
                {
                    field: "days",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Days"),
                    cellTooltip: true,
                    visible: true,
                    type: "string",
                    width: 75
                },
                {
                    field: "weeks",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Weeks"),
                    cellTooltip: true,
                    visible: true,
                    type: "string",
                    width: 75
                },
                {
                    field: "months",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Months"),
                    cellTooltip: true,
                    visible: true,
                    type: "string",
                    width: 75
                },
                {
                    field: "years",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Years"),
                    cellTooltip: true,
                    visible: true,
                    type: "string",
                    width: 75
                }
            ];

            $scope.protectPagePolicies.columnDefs = [
                {
                    field: "id",
                    visible: false
                },
                {
                    field: "systems[0].is_default",
                    displayName: gettextCatalog.getString("Default Policy"),
                    cellClass: function(grid, row, col){
                        if (grid.getCellValue(row,col) === true) {
                            return 'icon-default-policy';
                        }
                    },
                    headerCellFilter: 'translate',
                    visible: true,
                    cellTemplate: defaultTemplate,
                    type: 'string',
                    width: 72
                },

                {
                    field: "name",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Policy Name"),
                    cellTooltip: true,
                    visible: true,
                    type: "string"
                },
                {
                    field: "description",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Description"),
                    cellTooltip: true,
                    visible: true,
                    type: "string"
                },
                {
                    field: "days",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Days"),
                    cellTooltip: true,
                    visible: true,
                    type: "string",
                    width: 75
                },
                {
                    field: "weeks",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Weeks"),
                    cellTooltip: true,
                    visible: true,
                    type: "string",
                    width: 75
                },
                {
                    field: "months",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Months"),
                    cellTooltip: true,
                    visible: true,
                    type: "string",
                    width: 75
                },
                {
                    field: "years",
                    headerCellFilter: 'translate',
                    displayName: gettextCatalog.getString("Years"),
                    cellTooltip: true,
                    visible: true,
                    type: "string",
                    width: 75
                }
            ];

            $scope.assignSourcePolicies = {
                data: 'sourceAppliances',
                multiSelect: true,
                enableSelectAll: true,
                selectionRowHeaderWidth: 30,
                rowHeight: 26,
                enableFullRowSelection: true,
                enableFiltering: true,
                enableSorting: true,
                enableColumnResizing: true,
                gridMenuShowHideColumns: true,
                enableColumnMenus: true,
                enableGridMenu: true,
                enableHorizontalScrollbar: 0,
                columnDefs: [
                    {
                        field: "sid",
                        visible: false
                    },
                    {
                        field: "system_name",
                        headerCellFilter: 'translate',
                        displayName: gettextCatalog.getString("Appliance"),
                        cellTooltip: true,
                        visible: true,
                        type: "string"
                    },
                    {
                        field: "is_default",
                        headerCellFilter: 'translate',
                        displayName: gettextCatalog.getString("Default"),
                        headerTooltip: gettextCatalog.getString("Click 'Yes/No' in cell to edit"),
                        editableCellTemplate: 'ui-grid/dropdownEditor',
                        width: 80,
                        type: "boolean",
                        enableSorting: false,
                        cellFilter: 'mapDefault',
                        editDropdownValueLabel: 'default',
                        editDropdownOptionsArray: [{
                            id: true,
                            default: gettext('Yes')
                        }, {
                            id: false,
                            default: gettext('No')
                        }]
                    }
                ],
                onRegisterApi: function (gridApi) {
                    $scope.onRegisterApplianceGrid(gridApi);
                }

            };

            $scope.selectedSourceAppliances = [];
            $scope.onRegisterApplianceGrid = function (gridApi) {
                $scope.applianceGridAPI = gridApi;

                $timeout(function () {
                    // Select grid rows if appliances are already assigned to this policy.
                    $scope.assignSourcePolicies.data = $scope.sourceAppliances;
                    $scope.applianceGridAPI.grid.modifyRows($scope.assignSourcePolicies.data);
                    $scope.assignSourcePolicies.data.forEach(function (row) {
                        // Retain user selections for appliances in assign-source view between modal open/close
                        var isRowSelected = $scope.selectedSourceAppliances.filter(function (appliance) {
                            return appliance.system_id === row.sid;
                        }).length > 0;
                        if (isRowSelected) {
                            $scope.applianceGridAPI.selection.selectRow(row);
                        }
                    });
                });
            };

            $scope.addSourcesToPolicy = function(){
                var selected = [];
                $scope.selectedSourceAppliances = [];

                var selectedAppliances = $scope.applianceGridAPI.selection.getSelectedRows();
                if (selectedAppliances.length > 0){
                    for (var i = 0; i < selectedAppliances.length; i++){
                        var obj = {};
                        obj.system_id = selectedAppliances[i].sid;
                        obj.is_default = selectedAppliances[i].is_default;
                        selected.push(obj);
                    }
                    $scope.selectedSourceAppliances = selected;
                }
                $scope.closeAssignSourceDialog();
            };


            $scope.onRegisterGrid = function (gridApi) {
                $scope.gridApi = gridApi;
                gridApi.selection.on.rowSelectionChanged($scope, function (rows) {
                    var selectedItems = gridApi.selection.getSelectedRows();
                    if (selectedItems.length > 0) {
                        $scope.selectedItem = selectedItems[0];
                    } else if (selectedItems.length === 0) {
                        $scope.selectedItem = null;
                    }
                });
            };

            $http({
                method: 'get',
                url : $scope.copyEdit ? '/api/retention/strategy/onTarget' : '/api/retention/strategy/managed'
            }).success(function(data) {
                if ($scope.copyEdit) {
                    for (var i = 0; i < data.data.length; i++) {
                        var obj = {
                            id: data.data[i].sid,
                            name: data.data[i].system_name
                        };
                        $scope.applianceList.push(obj);
                    }
                } else {
                    for (var i = 0; i < data.data.LTR.length; i++) {
                        //Don't try to add a client to a system that is not available
                        if (data.data.LTR[i].status !== "not available") {
                            var obj = {
                                id: data.data.LTR[i].sid,
                                name: data.data.LTR[i].system_name
                            };
                            $scope.applianceList.push(obj);
                        }
                    }
                }

                for (var i = 0; i < $scope.applianceList.length; i++) {
                    $scope.sid = $scope.sid === undefined ? $rootScope.local.sid : $scope.sid;
                    if ($scope.applianceList[i].id === $scope.sid) {
                        $scope.selected = {};
                        $scope.selected = $scope.applianceList[i];
                    }
                }
            });

                $scope.loadTargetSources = function () {
                    $http({
                        method: 'get',
                        url: "/api/retention/strategy/onTarget/?sid=" + $scope.sid
                    }).success(function (data, status, headers) {
                        console.log(data);
                        if (data !== undefined && data.data !== undefined) {
                            var appliances = data.data;
                            if ($scope.policyEdit) {
                                // On Edit, make a copy of the systems associated with the policy.
                                // Compare policy systems with source list, set default based on the policy.
                                var policySystems = ($scope.selectedItem.systems instanceof Array) ? $scope.selectedItem.systems.slice(0) : [];
                                for (var i = 0; i < appliances.length; i++) {
                                    appliances[i].is_default = false;
                                    for (var j = 0; j < policySystems.length; j++) {
                                        if (appliances[i].sid === policySystems[j].system_id) {
                                            appliances[i].is_default = policySystems[j].is_default;
                                            break;
                                        }
                                    }
                                }
                            } else {
                                // On add, initialize default for all appliances to false.
                                for (i = 0; i < appliances.length; i++) {
                                    appliances[i].is_default = false;
                                }
                            }
                            $scope.sourceAppliances = appliances;
                            ngDialog.open({
                                template: 'app/configure/retention/assign-source.html',
                                overlay: true,
                                scope: $scope,
                                name: 'assign-source',
                                modelDialogId: 'assign-source',
                                ngDialogStyle: 'width:500px; height:auto; padding-bottom:50px',
                                closeByDocument: true,
                                closeByEscape: true
                            });
                        }
                    });
                };



            $scope.reloadGrid = function () {
                // Clean up user selections on grid reset
                $scope.selectedSourceAppliances = [];
                var load = PHD.showLoadingIndicator('body', true, "Getting Policies...");
                var url = "";
                if($scope.copyEdit){
                    url = "/api/retention/policy/?sid=" + $rootScope.local.id + "&source_id=" + $scope.sid;
                } else {
                    url = "/api/retention/policy/?sid=" + $scope.sid;
                }
                $http({
                    method: 'get',
                    url: url
                }).success(function (data, status, headers) {

                    PHD.hideLoadingIndicator(load);
                    $scope.selectedItem = null;
                    $scope.savedItem = null;

                    $timeout(function () {
                        if (data.data) {
                            $scope.policyData = data.data;
                            $scope.gridData = $scope.policyData;
                            var iconDefault = '<i class="icon-hv-vm';
                            for (var i = 0; i < $scope.policyData.length; i++){
                                if ($scope.policyData[i].systems.is_default === true){
                                    iconDefault += $scope.policyData[i].name;
                                    break;
                                }
                            }
                        }
                        $scope.$apply()
                    }, 0);
                }).error(function (response) {

                });
            };

            $scope.onChangeAppliance = function (sid){
                $scope.sid = sid;
                $scope.reloadGrid();
            };

        function handlePolicyError(jqXHR, textStatus, errorThrown) {
            if(jqXHR.status === 500) {
                var data = jqXHR.responseJSON;
                if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                    var error = data.result[0].message;
                // var errorMessage = "You must assign the policy to a source before you can add it."
                    console.log("The error is:" + error);
                    ngDialog.open({
                        dialogType:'Error',
                        modelDialogId:'GFSErrorDialog',
                        scope:$scope,
                        dialogMessage: error,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                } else {
                    PHD.throwError(data);
                }
            } else {
                PHD.ajaxError(jqXHR, textStatus, errorThrown);
            }
        }

        $scope.onConfirmError = function () {
            ngDialog.close('GFSErrorDialog');
        };

        function processDialog(PHD, window) {

            var $el = $("#retention-policy-dialog");
            var $retentionTable;
            var retentionSelect;
            var RetentionTable;
            var allRetention;
            var RetentionRowData = null;
            var base_url = "/api/retention/";
            var retentionEdit = false;

            /*
            * If on Copied Assets, get source appliances on this target.
            */
            if ($scope.ngDialogData !== undefined && $scope.ngDialogData.copiedAssets === true) {
                var url = "/api/retention/strategy/onTarget";
                $http({
                    method: 'get',
                    url: url
                }).success(function (data, status, headers) {
                    if (data.data) {
                        var systems = data.data;
                        for (var i = 0; i < systems.length; i++) {
                            $scope.sourcesOnTarget.push({'value': systems[i].sid, 'label': systems[i].system_name});
                        }
                    }
                }).error(function (response) {

                });
            }


            // function refreshRetentionList() {
            //     var retention = PHD.Ajax.get('/api/retention/policy/', null, handlePolicyError);
            //     allRetention = [];
            //     retention.done(function(data){
            //
            //         $scope.isPolicyGFS = true;
            //         var retentionList = data.data;
            //         retentionList.forEach(function(item, index) {
            //          item.id = item.id;
            //             if(item.systems.is_default){
            //                 item.name = item.name + " (default)";
            //             }
            //             if(item.is_global){
            //                 item.name = item.name + " (global)";
            //             }
            //          item.system_name = item.systems.name;
            //          item.is_default = item.systems.is_default;
            //          item.name = item.name;
            //          item.description = item.description;
            //          item.days = item.days;
            //          item.weeks = item.weeks;
            //          item.months = item.months;
            //          item.years = item.years;
            //          });
            //         allRetention = $.merge(allRetention, retentionList);
            //         RetentionTable.load(allRetention);
            //     });
            // }






            /* $scope.onChangeAppliance = function (sid) {
                    $scope.sid = sid;
                    $scope.reloadGrid();*/
            //   };



            //   $retentionTable = $el.find(".retention-table");
            //  RetentionTable = PHD.DataTable($retentionTable, {});
            // $scope.refreshRetentionList();

            /*  $retentionTable.on("rowselect", "tr", function (event, dbid, $el, DataTable, DataRow) {
                    if (DataRow !== undefined) {
                        RetentionRowData = DataRow.data;
                        PolicyName = RetentionRowData.name;
                        id = RetentionRowData.id;
                        isGlobal = RetentionRowData.is_global;
                        isDefault = RetentionRowData.systems.is_default;
                        if (RetentionRowData.days === "Forever") {
                            Days = "";
                        }
                        else {
                            Days = RetentionRowData.days;
                        }

                        if (RetentionRowData.weeks === "Forever") {
                            Weeks = "";
                        }
                        else {
                            Weeks = RetentionRowData.weeks;
                        }

                        if (RetentionRowData.months === "Forever") {
                            Months = "";
                        }
                        else {
                            Months = RetentionRowData.months;
                        }

                        if (RetentionRowData.years === "Forever") {
                            Years = "";
                        }
                        else {
                            Years = RetentionRowData.years;
                        }
                    }
                });*/
            };

            $scope.launchRetentionAddition = function () {
                // Since we are adding a new policy, no sources should be selected by default.
                $scope.selectedSourceAppliances = [];
                ngDialog.open({
                    template: 'app/configure/retention/retention.html',
                    name: 'Retention-Addition',
                    modelDialogId: 'Retention-Addition',
                    scope: $scope,
                    overlay: true,
                    ngDialogStyle: 'width:700px; height:600px;',
                    // GFS TODO - enlarge dialog once we have weekly/monthly/yearly settings
                    //ngDialogStyle:'width:700px; height:420px;',
                    closeByDocument: false,
                    closeByEscape: true,
                    showClose: false
                });

            };

            $scope.daySpinOptions = {"min": 0, "max": 32767, "step": 1};
            $scope.weekSpinOptions = {"min": 0, "max": 32767, "step": 1};
            $scope.monthSpinOptions = {"min": 0, "max": 32767, "step": 1};
            $scope.yearSpinOptions = {"min": 0, "max": 32767, "step": 1};

            $scope.processRetentionDialog = function () {
                $("#keep_days").spinner($scope.daySpinOptions);
                $("#keep_weeks").spinner($scope.weekSpinOptions);
                $("#keep_months").spinner($scope.monthSpinOptions);
                $("#keep_years").spinner($scope.yearSpinOptions);

            };


            // this can turn on and off spinners based on forever being checked or not.
            $scope.handleRetentionSpinner = function ($el, elSpinner) {
                var checked = $el.is(":checked");
                elSpinner.spinner("option", "disabled", checked);
            };

            $scope.processEditDialog = function () {
                // Initialize Spinners
                $scope.processRetentionDialog();

                //days = weeks = months = years = "";
                $("#policy-name").val($scope.selectedItem.name);
                $("#policy-description").val($scope.selectedItem.description);
                if (checkDefaultPolicy($scope.selectedItem)) {
                    $('#default').prop("checked", true);
                } else {
                    $('#default').prop("checked", false);
                }
                if ($scope.selectedItem.is_global === true) {
                    $('#global').prop("checked", true);
                } else {
                    $('#global').prop("checked", false);
                }
                if ($scope.selectedItem.days === 'Forever') {
                    $("#days-forever").prop("checked", true);
                    $scope.DaysForeverClicked();
                } else {
                    $("#keep_days").val($scope.selectedItem.days);
                    if ($scope.selectedItem.days === "") {
                        $("#keep_days").val("0");
                        $("#days-forever").prop("checked", true);
                        $("#keep_days").spinner("option", "disabled", true);
                        $("#weeks-forever").disable();
                        $("#keep_weeks").spinner("option", "disabled", true);
                        $("#months-forever").disable();
                        $("#keep_months").spinner("option", "disabled", true);
                        $("#years-forever").disable();
                        $("#keep_years").spinner("option", "disabled", true);
                    }
                }
                $("#keep_weeks").val($scope.selectedItem.weeks);
                if ($scope.selectedItem.weeks === "") {
                    $("#keep_weeks").val("0");
                    $("#weeks-forever").prop("checked", true);
                    $("#keep_weeks").spinner("disable");
                    $("#months-forever").disable();
                    $("#keep_months").spinner("disable");
                    $("#years-forever").disable();
                    $("#keep_years").spinner("disable");
                }
                $("#keep_months").val($scope.selectedItem.months);
                if ($scope.selectedItem.months === "") {
                    $("#keep_months").val("0");
                    $("#months-forever").prop("checked", true);
                    $("#keep_months").spinner("disable");
                    $("#years-forever").disable();
                    $("#keep_years").spinner("disable");
                }
                $("#keep_years").val($scope.selectedItem.years);
                if ($scope.selectedItem.years === "") {
                    $("#keep_years").val("0");
                    $("#keep_years").spinner("disable");
                    $("#years-forever").prop("checked", true);
                }
                if ($scope.selectedItem.days === "") {
                    daysToKeep = -1;
                } else {
                    daysToKeep = Number($scope.selectedItem.days);
                }
                if ($scope.selectedItem.weeks === "") {
                    weeksToKeep = -1;
                } else {
                    weeksToKeep = Number($scope.selectedItem.weeks);
                }
                if ($scope.selectedItem.months === "") {
                    monthsToKeep = -1;
                } else {
                    monthsToKeep = Number($scope.selectedItem.months);
                }
                if ($scope.selectedItem.years === "") {
                    yearsToKeep = 1;
                } else {
                    yearsToKeep = Number($scope.selectedItem.years);
                }

            };

            $scope.launchRetentionEditor = function () {
                // pre-populate selected source appliances with those already selected by retention policy being edited.
                $scope.selectedSourceAppliances = $scope.selectedItem ? jQuery.extend(true, [], $scope.selectedItem.systems) : [];
                ngDialog.open({
                    template: 'app/configure/retention/retention.html',
                    name: 'Retention-Edit',
                    modelDialogId: 'Retention-Edit',
                    scope: $scope,
                    overlay: true,
                    ngDialogStyle: 'width:700px; height:600px;',
                    // GFS TODO - enlarge dialog once we have weekly/monthly/yearly settings
                    //ngDialogStyle:'width:700px; height:420px;',
                    closeByDocument: false,
                    closeByEscape: true,
                    showClose: false
                });

            };

            $scope.ShowCalendar = function () {
                ngDialog.open({
                    template: 'app/configure/retention/calendarview.html',
                    scope: $scope,
                    overlay: true,
                    ngDialogStyle: 'width:500px; height:500px;',
                    closeByDocument: false,
                    closeByEscape: true,
                    showClose: false
                });
            };

            $scope.confirmEdit = function(){
                var policyEditCheckbox = $('#policyEditCheckbox');
                var saveButton =  $('#save_policy');

                policyEditCheckbox.on('change', function () {
                        saveButton.prop("disabled", !this.checked);//true:disabled, false:enabled
                    }).trigger('change'); //page load trigger event


            };

            $scope.AddRetentionInfo = function () {
                var obj = {};

                var policy_name = $("#policy-name").val();
                var policy_description = $("#policy-description").val();


                if (policy_name != "") {
                    if (policy_name.toLocaleUpperCase() !== "MULTIPLE" && policy_name.toLocaleUpperCase() !== "NONE") {
                        if ($("#default").prop("checked")) {
                            obj.is_default = true;
                        }


                        if (policy_name.indexOf("(default)") > -1) {
                            var name = policy_name;
                            name = name.replace('(default)', '');
                            obj.name = name;
                            $scope.isDefaultPolicy = true;
                        }
                        else {
                            obj.name = policy_name;
                            $scope.isDefaultPolicy = false;

                        }
                        if ($("#global").prop("checked")) {
                            obj.is_global = true;
                        }

                        obj.description = $("#policy-description").val();
                        obj.days = Number($("#keep_days").val());
                        obj.weeks = Number($("#keep_weeks").val());
                        obj.months = Number($("#keep_months").val());
                        obj.years = Number($("#keep_years").val());

                        if ($scope.copyEdit) {
                            obj.systems = $scope.selectedSourceAppliances;
                        }

                        if ($("#days-forever").prop("checked")) {
                            obj.days = -1;
                            obj.weeks = 0;
                            obj.months = 0;
                            obj.years = 0;
                        } else if ($("#weeks-forever").prop("checked")) {
                            obj.weeks = -1;
                            obj.months = 0;
                            obj.years = 0;
                        } else if ($("#months-forever").prop("checked")) {
                            obj.months = -1;
                            obj.years = 0;
                        } else if ($("#years-forever").prop("checked")) {
                            obj.years = -1;
                        }


                        var base_url = "/api/retention/policy/";

                        obj = JSON.stringify(obj);
                        sid = $scope.copyEdit ? $rootScope.local.id : $scope.sid;
                        if ($scope.policyEdit) {
                            base_url += $scope.selectedItem.id + "/";
                            resp = PHD.Ajax.put(base_url + "?sid=" + sid, obj, null, handlePolicyError);
                        }
                        else {
                            resp = PHD.Ajax.post(base_url + "?sid=" + sid, obj, null, handlePolicyError);
                        }

                        resp.done(function (data) {
                            var result = data.result[0];
                            if (parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                                console.log("SUCCESS");
                                policiesAdded = !$scope.policyEdit;
                                $scope.reloadGrid();
                                $scope.closeAddEditDialog();

                            } else if (parseInt(result.code) === AJAX_RESULT_ERROR) {
                                console.log("FAILURE");
                                ngDialog.open({
                                    dialogType: 'ERROR',
                                    dialogMessage: data,
                                    overlay: true
                                });
                            }
                        });
                    } else {
                        ngDialog.open({
                            dialogType: 'Error',
                            modelDialogId: 'GFSErrorDialog',
                            dialogMessage:  policy_name + ' is a reserved policy name.',
                            scope: $scope,
                            onConfirmOkButtonClick: 'onConfirmError()'
                        });
                    }
                } else {
                    ngDialog.open({
                        dialogType: 'Error',
                        modelDialogId: 'GFSErrorDialog',
                        dialogMessage: 'Please enter policy name',
                        scope: $scope,
                        onConfirmOkButtonClick: 'onConfirmError()'
                    });
                }
            };

            $scope.RetentionRemove = function () {
                $scope.deleteTitle = gettextCatalog.getString('Confirm Delete Policy');

                var name = $scope.selectedItem.name;
                if (checkDefaultPolicy($scope.selectedItem)) {
                    var message = gettextCatalog.getString('Policy') + ' ' + name + ' ' +
                                    gettextCatalog.getString('is a default retention policy, and default policies cannot be deleted.');
                    ngDialog.open({
                        dialogType:'Error',
                        modelDialogId:'GFSErrorDialog',
                        scope:$scope,
                        dialogMessage: message,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                } else {
                    $scope.confirmMessage1 = gettextCatalog.getString('Are you sure you want to delete the selected policy: ' + name + '?');
                    $scope.confirmMessage2 = gettextCatalog.getString('The policy will be removed from any associated assets and the corresponding backups may not be retained.');
                    $scope.confirmMessage3 = gettextCatalog.getString('I understand deleting this policy may result in backups for associated assets being purged.');
                    $scope.submitButtonText = gettextCatalog.getString('Delete Policy');

                    ngDialog.open({
                        template: 'app/common/confirmationDialog.html',
                        scope: $scope,
                        overlay: true,
                        modelDialogId: 'delete-policy-dialog',
                        ngDialogStyle: 'width:620px;height:250px',
                        closeByDocument: false,
                        closeByEscape: true
                    });

                    // Required name for common delete function.
                    $scope.closeThisDialog = function () {
                        ngDialog.close("delete-policy-dialog");
                    };
                }

            };

            $scope.deleteAsset = function () {
                ngDialog.close('delete-policy-dialog');
                var base_url = "/api/retention/policy/";
                base_url += $scope.selectedItem.id + "/";
                sid = $scope.copyEdit ? $rootScope.local.id : $scope.sid;
                resp = PHD.Ajax.delete(base_url + "?sid=" + sid);
                resp.done(function (data) {
                    var result = data.result[0];
                    if (parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                        policiesDeleted = true;
                        $scope.reloadGrid();
                    } else if (parseInt(result.code) === AJAX_RESULT_ERROR) {
                        ngDialog.open({
                            dialogType: 'ERROR',
                            dialogMessage: data,
                            overlay: true
                        });
                    }
                });

            };

            $scope.DaysForeverClicked = function () {
                $scope.handleRetentionSpinner($("#days-forever"), $("#keep_days"));
                if ($("#days-forever").prop("checked")) {
                    console.log("Days forever enabled");
                    $("#keep_days").spinner("disable");
                    $("#keep_days").val("0");
                    $("#weeks-forever").disable();
                    $('#weeks-forever').prop("checked", false);
                    $("#keep_weeks").spinner("disable");
                    $("#keep_weeks").val("0");
                    $("#months-forever").disable();
                    $("#months-forever").prop("checked", false);
                    $("#keep_months").spinner("disable");
                    $("#keep_months").val("0");
                    $("#years-forever").disable();
                    $("#years-forever").prop("checked", false);
                    $("#keep_years").spinner("disable");
                    $("#keep_years").val("0");
                }
                else {
                    console.log("Days forever disabled");
                    $("#keep_days").spinner("enable");
                    $("#weeks-forever").enable();
                    $("#keep_weeks").enable();
                    $("#keep_weeks").spinner("enable");
                    $("#months-forever").enable();
                    $("#keep_months").enable();
                    $("#keep_months").spinner("enable");
                    $("#years-forever").enable();
                    $("#keep_years").enable();
                    $("#keep_years").spinner("enable");
                }
                //  onSpinnerChange();
            };

            $scope.WeeksForeverClicked = function () {
                $scope.handleRetentionSpinner($("#weeks-forever"), $("#keep_weeks"));
                if ($("#weeks-forever").prop("checked")) {
                    console.log("Weeks forever enabled");
                    $("#keep_weeks").val("0");
                    $("#keep_weeks").spinner("disable");
                    $("#months-forever").disable();
                    $('#months-forever').prop("checked", false);
                    $("#keep_months").spinner("disable");
                    $("#keep_months").val("0");
                    $("#years-forever").disable();
                    $("#years-forever").prop("checked", false);
                    $("#keep_years").spinner("disable");
                    $("#keep_years").val("0");
                } else {
                    console.log("Weeks forever disabled");
                    $("#keep_weeks").spinner("enable");
                    $("#months-forever").enable();
                    $("#keep_months").enable();
                    $("#keep_months").spinner("enable");
                    $("#years-forever").enable();
                    $("#keep_years").enable();
                    $("#keep_years").spinner("enable");
                }
                // onSpinnerChange();
            };

            $scope.MonthsForeverClicked = function () {
                $scope.handleRetentionSpinner($("#months-forever"), $("#keep_months"));
                if ($("#months-forever").prop("checked")) {
                    console.log("Months forever enabled");
                    $("#keep_months").val("0");
                    $("#keep_months").spinner("disable");
                    $("#years-forever").disable();
                    $("#years-forever").prop("checked", false);
                    $("#keep_years").spinner("disable");
                    $("#keep_years").val("0");
                } else {
                    console.log("Months forever disabled");
                    $("#keep_months").spinner("enable");
                    $("#years-forever").enable();
                    $("#keep_years").enable();
                    $("#keep_years").spinner("enable");
                }
                //onSpinnerChange();
            };

            $scope.YearsForeverClicked = function () {
                if ($("#years-forever").prop("checked")) {
                    console.log("Years forever enabled");
                    $("#keep_years").spinner("disable");
                    $("#keep_years").val("0");
                } else {
                    console.log("Years forever disabled");
                    $("#keep_years").spinner("enable");
                }
                // onSpinnerChange();
            };

            $scope.closeAddEditDialog = function () {
                // Clean up user selections on dialog close
                $scope.selectedSourceAppliances = [];

                var dialogId = $scope.policyEdit ? 'Retention-Edit' : 'Retention-Addition';
                ngDialog.close(dialogId);
            };

            $scope.closeThisDialog = function() {
                if (policiesAdded || policiesDeleted) {
                    // Let others know if any policies were added or deleted.
                    $rootScope.$broadcast('policiesModified', { 'policiesAdded': policiesAdded, 'policiesDeleted': policiesDeleted });
                }
                if ( _.isFunction(unbindHandler)) {
                    unbindHandler();
                }
                ngDialog.close('Retention-Policy');
            };

            $scope.closeAssignSourceDialog = function() {
                ngDialog.close('assign-source');
            };

            // Initialize the controller.
            unbindHandler = $scope.$on('ngDialog.opened', function (event, obj) {
                $scope.initCtrl(obj)
            });
        }])

        .factory('retentionsvc', function($http, $q) {
                return {
                    getStrategy: function(sid) {
                        var deferred = $q.defer();
                        $http.get('/api/retention/strategy/?sid=' + sid)
                            .success(function(data, status, headers) {
                                if (data !== undefined && data.data !== undefined) {
                                    deferred.resolve(data.data.strategy);
                                } else {
                                    deferred.reject('error');
                                }
                            })
                            .error(function(response) {
                                // log error on strategy.
                                console.log("Error getting retention strategy.");
                                deferred.reject('error');
                            });
                        return deferred.promise;
                    }
                };
            }
        )
        .filter('mapDefault', function() {
            return function (input) {
                var value = gettext("No");
                if (input === true) {
                    value = gettext("Yes");
                }
                return value;
            };
        });
