var imageLevelInstantRecoverModule = angular.module('imageLevelInstantRecoveryModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid.selection']);

imageLevelInstantRecoverModule.config(['ngDialogProvider', function (ngDialogProvider) {
    ngDialogProvider.setDefaults({
        plain: false,
        closeByDocument: true,
        closeByEscape: true,
        appendTo: false,
        preCloseCallback: function (value) {

        }
    });
}]);


imageLevelInstantRecoverModule.factory('imageLevelInstantRecoveryFactory', function($http,ngDialog) {
    return {
        getHypervisorDetail: function(method, url, sid,dataObj, hypervisor_type, hypervisor) {
            var params = {};
            if (sid != 0) {
                params.sid = sid;

                if(hypervisor_type !== "" && hypervisor!==""){
                    params.type = hypervisor_type;
                    params.os_id = parseInt(hypervisor);
                }                }
            var promise = $http({
                url: url,
                data: dataObj,
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });
            });
            return promise;
        }
    };
});

imageLevelInstantRecoverModule.factory('imageLevelNetworkDataFactory', function($http,ngDialog) {
    return {
        getHypervisorSwitchNetWorkDetails: function(method, url, sid,dataObj, hypervisor_type, hypervisor) {
            var params = {};
            if (sid != 0) {
                params.sid = sid;

                if(hypervisor_type !== "" && hypervisor!==""){
                    params.hypervisor_type = hypervisor_type;
                    params.hypervisor = hypervisor;
                }

            }
            var promise = $http({
                url: url,
                data: dataObj,
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });

            });
            return promise;
        }
    };
});

imageLevelInstantRecoverModule.factory('imageLevelApplianceNetworkFactory', function($http,ngDialog) {
    return {
        getApplianceNetworkDetails: function(method, url, sid) {
            var params = {};
            if (sid != 0) {
                params.sid = sid;

            }
            var promise = $http({
                url: url,
                method: method,
                params: params
            }).success(function(data, status, headers){

            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });

            });
            return promise;
        }
    };
});

imageLevelInstantRecoverModule.controller('imageLevelInstantRecoveryCtrl', ['$scope', '$rootScope', '$http', '$timeout', 'ngDialog', 'wizardService', '$analytics', 'imageLevelInstantRecoveryFactory', 'imageLevelNetworkDataFactory', 'imageLevelApplianceNetworkFactory','gettextCatalog',
    function($scope, $rootScope, $http, $timeout, ngDialog, wizardService, $analytics, imageLevelInstantRecoveryFactory, imageLevelNetworkDataFactory, imageLevelApplianceNetworkFactory, gettextCatalog) {


        $scope.hideRSP = false;
        $scope.isUnitrendAppliance = false;

        $scope.selectedImageLevelHypervisorType ="";
        $scope.hypervisor_type="";
        $scope.showTargetNetworkSwitch = true;

        $scope.imageLevelInstantRecoverySummaryHeaderArray = [];

        $scope.imageLevelHypervisorTypes= $rootScope.isUEB ? ["VMware host", "Hyper-V host"] : ["VMware host", "Hyper-V host", "Unitrends Appliance"];
        $scope.imageLevelHypervisorLocations = [];
        $scope.dataStores = [];
        $scope.dataStoresPools = [];
        $scope.networkSwitches = [];
        $scope.applianceNetworks = [];
        $scope.resourcePoolRequired = false;

        $scope.hypervisorId = "";

        $scope.imageLevelInstantRecoveryVMOptions = {};
        $scope.imageLevelInstantRecoveryVMOptions.selectedNetwork ="";
        $scope.imageLevelInstantRecoveryVMOptions.selecteddataStorePool="";
        $scope.imageLevelInstantRecoveryVMOptions.ImageLevelLocationObj="";
        $scope.imageLevelInstantRecoveryVMOptions.selecteddataStore="";
        $scope.imageLevelInstantRecoveryVMOptions.network_switch="";
        $scope.imageLevelInstantRecoveryVMOptions.audit = false;

        $scope.imageLevelInstantRecoverySummaryHeaderArray = [{"labelName": "Asset Name", "labelDescription": selectedBackup.vm_name},
            {
                "labelName": "Backup Details",
                "labelDescription": selectedBackup.backup_type + " " + selectedBackup.backup_date
            },
            {"labelName": "Size", "labelDescription": selectedBackup.backup_size + " MB"}
        ];

        //API execute after selection type.

        /********************************************/

        $scope.collectDataStore = [];
        //Retrieving data as per Type selection.
        $scope.selectedImageLevelHypervisorTypeChange = function(selectedType){
            var load = PHD.showLoadingIndicator("body", true, "Loading...");

            $scope.imageLevelHypervisorLocations        = []; //reset combo before get data .
            $scope.dataStores       = []; //reset combo before get data .
            $scope.dataStoresPools  = []; //reset combo before get data .
            $scope.networkSwitches         = []; //reset combo before get data .
            $scope.collectDataStore = [];

            $scope.imageLevelInstantRecoveryVMOptions.ImageLevelLocationObj = "";
            $scope.imageLevelInstantRecoveryVMOptions.network_switch = "";
            $scope.showTargetNetworkSwitch = true;

            if(selectedType !=="" && typeof(selectedType) !== "undefined" && selectedType !== null){
                $scope.selectedImageLevelHypervisorType = selectedType;
            }else {
                $scope.selectedImageLevelHypervisorType = null;
                $scope.hypervisor_type = null;
            }

            if($scope.selectedImageLevelHypervisorType === HYPERVISOR_VMWARE_HOST){
                $scope.hypervisor_type = "VMware";
                $scope.hideRSP = false;
                $scope.isUnitrendAppliance = false;
                $scope.showTargetNetworkSwitch = ($scope.imageLevelInstantRecoveryVMOptions.audit === false );
            }else if($scope.selectedImageLevelHypervisorType === HYPERVISOR_HYPERV_HOST){
                $scope.hypervisor_type = "Hyper-V";
                $scope.hideRSP = true;
                $scope.isUnitrendAppliance = false;
                $scope.showTargetNetworkSwitch = ($scope.imageLevelInstantRecoveryVMOptions.audit === false );
            }else if($scope.selectedImageLevelHypervisorType === HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED){
                $scope.hypervisor_type = "appliance";
                $scope.hideRSP = true;
                $scope.isUnitrendAppliance = true;
                $scope.showTargetNetworkSwitch = false;
            }

            // API Call for retrieving data for target details.
            if(!$scope.isUnitrendAppliance && $scope.hypervisor_type !== null){
                var locationURL =  "/api/virtual_clients/targets/";
                var sid = (selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid;

                imageLevelInstantRecoveryFactory.getHypervisorDetail('get',locationURL,sid,"", $scope.hypervisor_type, selectedBackup.client_os_id).then(function(data){

                    $scope.imageLevelHypervisorLocations        = []; //reset combo before get data .
                    $scope.dataStores       = []; //reset combo before get data .
                    $scope.dataStoresPools  = []; //reset combo before get data .
                    $scope.networkSwitches  = []; //reset combo before get data .

                    angular.forEach(data.data.targets, function(value, key) {
                        var locationTempObj = {};
                        locationTempObj.value = value.id;
                        locationTempObj.name = value.name;
                        $scope.imageLevelHypervisorLocations.push(locationTempObj);

                        if($scope.hypervisor_type === "Hyper-V")
                            $scope.hypervisorId = value.name;
                        else if($scope.hypervisor_type === "VMware")
                            $scope.hypervisorId = value.id;

                        $scope.collectDataStore = data.data.targets;
                    });

                    PHD.hideLoadingIndicator(load);
                });// End target Location retrieving.

                var network_url = "/api/networks/";
                imageLevelApplianceNetworkFactory.getApplianceNetworkDetails('get', network_url, (selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid)
                    .then(function (data) {
                        $scope.applianceNetworks = [];
                        var restore_networks = data.data.networks;
                        if (restore_networks && restore_networks != undefined && restore_networks.length > 0) {
                            angular.forEach(restore_networks, function (network, index) {
                                if (network.ip != "") {
                                    var networkTempObj = {};
                                    networkTempObj.value = network.ip;
                                    networkTempObj.name = network.id + " - " + network.ip;
                                    $scope.applianceNetworks.push(networkTempObj);
                                }
                            });
                            $scope.imageLevelInstantRecoveryVMOptions.selectedNetwork = $scope.applianceNetworks[0].value;
                        }
                    });
                $scope.networkRequired = ($scope.imageLevelInstantRecoveryVMOptions.audit === false );  // network is optional for Audit mode

            }else{
                PHD.hideLoadingIndicator(load);
            }

            if($scope.selectedImageLevelHypervisorType === HYPERVISOR_VMWARE_HOST){
                storageDisplayName = "TARGET STORAGE";
                assetDisplayName = "VM NAME";
                targetDisplayName = "TARGET HOST";
            }else if($scope.selectedImageLevelHypervisorType === HYPERVISOR_HYPERV_HOST){
                storageDisplayName = "TARGET DIRECTORY";
                assetDisplayName = "VM NAME";
                targetDisplayName = "TARGET HOST";
            }else if($scope.selectedImageLevelHypervisorType === HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED){
                assetDisplayName = "RECOVERY ASSET";
                targetDisplayName = "TARGET";
            }

            $scope.imageLevelInstantRecoverGridOptions = {
                enableColumnMenus:false,
                enableHorizontalScrollbar: 0,
                columnDefs: [
                    { field: 'vm_name',displayName:assetDisplayName,resizable:true,cellTemplate:editSuffixesCellTemplate},
                    { field: 'target_host',displayName:targetDisplayName},
                    { field: 'target_resource',displayName:"TARGET RESOURCE", visible:($scope.selectedImageLevelHypervisorType === HYPERVISOR_VMWARE_HOST)? true:false },
                    //{ field: 'instance_name', displayName:instanceDisplayName, visible:($scope.selectedImageLevelHypervisorType === APPLICATION_TYPE_NAME_SQL_SERVER) ? true : false},
                    { field: 'target_storage',displayName:storageDisplayName, visible:($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED)? true:false },
                    { field: 'appliance_network',displayName:"APPLIANCE NETWORK", visible:($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED)? true:false },
                    { field: 'network_switch',displayName:"NETWORK SWITCH",visible:($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED)? true:false }
                ]
            };
        };

        $scope.imageLevelLocationChange = function(location){
            $scope.dataStoresPools=[];

            if($scope.imageLevelInstantRecoveryVMOptions.ImageLevelLocationObj!=="" && typeof($scope.imageLevelInstantRecoveryVMOptions.ImageLevelLocationObj) !== "undefined"){
                $scope.dataStoresPools=[];
                for(var i=0; i<$scope.collectDataStore.length; i++){

                    if(typeof($scope.collectDataStore[i].groups) !== 'undefined'){
                        if($scope.collectDataStore[i].id  == location){
                            $scope.imageLevelInstantRecoveryVMOptions.selecteddataStorePool="";
                            angular.forEach($scope.collectDataStore[i].groups.VG, function(value, key) {
                                var obj={
                                    name:value.Name,
                                    value:value.Key
                                };
                                $scope.dataStoresPools.push(obj);

                            });
                        }
                    }
                }
                $scope.networkCheck=false;
                $scope.dataStores=[];
                if(typeof($scope.collectDataStore) != "undefined")
                    for(var i=0; i<$scope.collectDataStore.length; i++){
                        console.log($scope.collectDataStore[i].id);
                        if($scope.collectDataStore[i].id  == location){
                            console.log($scope.collectDataStore[i]);
                            if(typeof($scope.collectDataStore[i].datastores) != "undefined"){
                                $scope.networkCheck=true;
                                console.log('collectDataStore[i].datastores');
                                for(var j=0; j<$scope.collectDataStore[i].datastores.length; j++){
                                    $scope.dataStores.push($scope.collectDataStore[i].datastores[j].name);

                                }
                            }
                        }
                    }
            }

            //API Call for retrieving data of Network as per selection type.
            if($scope.imageLevelInstantRecoveryVMOptions.ImageLevelLocationObj){

                var load = PHD.showLoadingIndicator("body", true, "Loading...");
                $scope.imageLevelInstantRecoveryVMOptions.locationName = $.grep($scope.imageLevelHypervisorLocations, function (location) {
                    return location.value == $scope.imageLevelInstantRecoveryVMOptions.ImageLevelLocationObj;
                })[0].name;

                var networkURL ="/api/networks/hypervisor-switch/";
                if($scope.hypervisor_type === "Hyper-V"){
                    $scope.hypervisorId = $scope.imageLevelInstantRecoveryVMOptions.locationName;
                }else if($scope.hypervisor_type === "VMware"){
                    $scope.hypervisorId = $scope.imageLevelInstantRecoveryVMOptions.ImageLevelLocationObj;
                }
                var sid = (selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid;

                if($scope.networkCheck){
                    imageLevelNetworkDataFactory.getHypervisorSwitchNetWorkDetails('get',networkURL,sid,"",$scope.hypervisor_type,$scope.hypervisorId).then(function(data){
                        PHD.hideLoadingIndicator(load);
                        $scope.networkSwitches =[];
                        angular.forEach(data.data.names, function(value, key) {
                            $scope.networkSwitches.push(value);
                        });
                    });
                }else{
                    PHD.hideLoadingIndicator(load);

                }


            }
        };

        $scope.auditChange = function () {
            if ($scope.selectedImageLevelHypervisorType === HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED) {
    // never show it for the Appliance
                $scope.showTargetNetworkSwitch = false;
            } else {
                $scope.showTargetNetworkSwitch = ($scope.imageLevelInstantRecoveryVMOptions.audit === false );
            }

            if ($scope.showTargetNetworkSwitch === false) {
                // if we turn it off, blank it, otherwise the leftover name could remain in the buffer that could carry forward.
                $scope.imageLevelInstantRecoveryVMOptions.network_switch = "";
            }
        };

        /********************************** Recover summary grid**************************/
        var editSuffixesCellTemplate = '<div style="padding-top:5px;" ng-click="grid.appScope.openEditNameDialog(row.entity,row.getProperty(col.field), col.field)"><div style="font-size: 1em;padding-left:5px;text-overflow:ellipsis;float:left;">{{row.entity.vm_name}}</div><div style="float:right;padding-right:5px;" title="Edit VM Name"><img  src="assets/images/edit_pencil.png" style="height:14px;cursor:pointer;"/></div></div>';

        var storageDisplayName = "";
        var assetDisplayName = "";
        var targetDisplayName = "";
        var instanceDisplayName = "";
        if($scope.selectedImageLevelHypervisorType === HYPERVISOR_VMWARE_HOST){
            storageDisplayName = "TARGET STORAGE";
            assetDisplayName = "VM NAME";
            targetDisplayName = "TARGET HOST";
        }else if($scope.selectedImageLevelHypervisorType === HYPERVISOR_HYPERV_HOST){
            storageDisplayName = "TARGET DIRECTORY";
            assetDisplayName = "VM NAME";
            targetDisplayName = "TARGET HOST";
        }else if($scope.selectedImageLevelHypervisorType === HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED){
            assetDisplayName = "RECOVERY ASSET";
            targetDisplayName = "TARGET";
        }

        $scope.imageLevelInstantRecoverGridOptions = {
            enableColumnMenus:false,
            enableHorizontalScrollbar: 0,
            columnDefs: [
                { field: 'vm_name',displayName:assetDisplayName,resizable:true,cellTemplate:editSuffixesCellTemplate},
                { field: 'target_host',displayName:targetDisplayName},
                { field: 'target_resource',displayName:"TARGET RESOURCE", visible:($scope.selectedImageLevelHypervisorType === HYPERVISOR_VMWARE_HOST)? true:false },
                { field: 'target_storage',displayName:storageDisplayName, visible:($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED)? true:false },
                { field: 'appliance_network',displayName:"APPLIANCE NETWORK", visible:($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED)? true:false },
                { field: 'network_switch',displayName:"NETWORK SWITCH",visible:($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED)? true:false }
            ]
        };

        /********************************** Function to edit recovered VM name *********************/
        $scope.openEditNameDialog = function(row, cell, col) {
            $scope.selectedRow = row;
            $scope.selectedColumn = col;
            $scope.VmName = row.vm_name;
            $scope.imageLevelRecoverVM = {};
            $scope.imageLevelRecoverVM.name = $scope.VmName;
            ngDialog.open({
                template: 'app/recover/imageLevelInstantRecovery/editImageLevelInstantRecoveryName.html',
                scope: $scope,
                overlay: true,
                modelDialogId: 'image_level_instant_recovery_name_dialogId',
                ngDialogStyle: 'width:42em; height:16em;'
            });

        };

        $scope.updateRecoveryName = function(){
            $scope.VmName = $scope.imageLevelRecoverVM.name;
            console.log($scope.VmName);
            $scope.getSummaryDetail($scope.VmName);
            ngDialog.close('image_level_instant_recovery_name_dialogId');
        };

        /************************ On click of wizard next button ***************************/


        $scope.nextStepWizard = function($event){
            //Step 1st
            if(wizardTitle === "Define Recovery Options"){
                if (checkValidationForImageLevelInstantRecoveryLocation(gettextCatalog, $scope.isUnitrendAppliance)) {
                    $scope.getSummaryDetail("");
                    $rootScope.$broadcast("nextBtnClick");
                }
            }else if(wizardTitle === "Summary"){
                $scope.postRecoverData();
            }
        };


        /********************************** Function to get summary detail*********************/
        $scope.getSummaryDetail = function(vmNameParam){
            var network = "";
            var vmName = "";
            var switchName = "";
            var hostName = "";
            var storageName = "";
            var instanceName = "";
            var resourcePool = "";
            if (vmNameParam != "" && vmNameParam != undefined) {
                vmName = vmNameParam;
            } else {
                vmName = selectedBackup.vm_name+ '_restore'; //VM name should have '_restore' appended in case of vmware.
            }
            if ( $scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED ) {
                network = $scope.imageLevelInstantRecoveryVMOptions.selectedNetwork;
                storageName = $scope.imageLevelInstantRecoveryVMOptions.selecteddataStore;
                hostName = $scope.imageLevelInstantRecoveryVMOptions.locationName;
                switchName = $scope.imageLevelInstantRecoveryVMOptions.network_switch;
                if ($scope.selectedImageLevelHypervisorType === HYPERVISOR_VMWARE_HOST && $scope.imageLevelInstantRecoveryVMOptions !== undefined) {
                    resourcePool = $scope.imageLevelInstantRecoveryVMOptions.selecteddataStorePool;
                }
            } else {
                // Unitrends Appliance Qemu Block IR
                hostName = HYPERVISOR_UNITRENDS_APPLIANCE;
            }

            if($scope.selectedImageLevelHypervisorType === HYPERVISOR_VMWARE_HOST){
                storageDisplayName = "TARGET STORAGE";
                assetDisplayName = "VM NAME";
                targetDisplayName = "TARGET HOST";
            }else if($scope.selectedImageLevelHypervisorType === HYPERVISOR_HYPERV_HOST){
                storageDisplayName = "TARGET DIRECTORY";
                assetDisplayName = "VM NAME";
                targetDisplayName = "TARGET HOST";
            }else if($scope.selectedImageLevelHypervisorType === HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED){
                assetDisplayName = "RECOVERY ASSET";
                targetDisplayName = "TARGET";
            }

            $scope.imageLevelInstantRecoverGridOptions.columnDefs = [
                { field: 'vm_name',displayName:assetDisplayName,resizable:true,cellTemplate:editSuffixesCellTemplate},
                { field: 'target_host',displayName:targetDisplayName},
                { field: 'target_resource',displayName:"TARGET RESOURCE", visible:($scope.selectedImageLevelHypervisorType === HYPERVISOR_VMWARE_HOST)? true:false },
                { field: 'target_storage',displayName:storageDisplayName, visible:($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED)? true:false },
                { field: 'appliance_network',displayName:"APPLIANCE NETWORK", visible:($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED)? true:false },
                { field: 'network_switch',displayName:"NETWORK SWITCH",visible:($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED)? true:false }
            ];
            $scope.imageLevelInstantRecoverGridOptions.data = [
                {
                    "vm_name": vmName,
                    "target_host": hostName,
                    "target_resource": resourcePool,
                    "target_storage": storageName,
                    "appliance_network": network,
                    "network_switch": switchName
                }
            ];
            console.log($scope.imageLevelInstantRecoverGridOptions.data);
        };

        /************************ Function to post the recover data to backend **********/
        $scope.postRecoverData = function() {

            $scope.restoreObj = {};
            $scope.restoreObj.image_level = true;
            switch ( $scope.selectedImageLevelHypervisorType ) {
                case HYPERVISOR_VMWARE_HOST:
                    $scope.restoreObj.hypervisor_type = APPLICATION_TYPE_NAME_VMWARE;
                    break;
                case HYPERVISOR_HYPERV_HOST:
                    $scope.restoreObj.hypervisor_type = APPLICATION_TYPE_NAME_HYPER_V;
                    break;
                case HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED:
                    $scope.restoreObj.hypervisor_type = "appliance";
                    break;
                default:
                    //Qemu
                    break;
            }
            $scope.restoreObj.target = {};

            $scope.restoreObj  = $scope.collectRecoverData();

            console.log('=== Submit form: object = ' + JSON.stringify($scope.restoreObj));
            var url = "/api/restore/instant/";
            var params = {};
            params.sid = (selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid;
            var load = PHD.showLoadingIndicator("body", true, "Starting Recovery...");

            $http ({
                method: 'post',
                url : url,
                data: JSON.stringify($scope.restoreObj),
                params: params
            }).success(function(data){
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'Information',
                    scope:$scope,
                    dialogMessage:"Instant Recovery has started successfully"
                });
                //ngDialog.close('recover-dialog');

            }).error(function(response) {
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'retry',
                    dialogMessage:response.result[0].message
                })
            });
        };

        /****************** Function to collect restore data of VMware and Hyper-V AND XEN**************/
        $scope.collectRecoverData = function(){
            if ($scope.selectedImageLevelHypervisorType === HYPERVISOR_HYPERV_HOST) {
                $scope.restoreObj.target.host = $scope.imageLevelInstantRecoveryVMOptions.locationName;
            } else if ($scope.selectedImageLevelHypervisorType === HYPERVISOR_VMWARE_HOST) {
                $scope.restoreObj.target.host = $scope.imageLevelInstantRecoveryVMOptions.ImageLevelLocationObj;
                $scope.restoreObj.target.datastore = $scope.imageLevelInstantRecoveryVMOptions.selecteddataStore;
                $scope.restoreObj.target.group = $scope.imageLevelInstantRecoveryVMOptions.selecteddataStorePool;
                console.log("RP name " + $scope.restoreObj.target.group);
            }

            $scope.restoreObj.target.name = $scope.imageLevelInstantRecoverGridOptions.data[0].vm_name;
            console.log("VM name " + $scope.restoreObj.target.name);

            //if 'original location' is selected in Hyper-V restores, do not set 'directory'
            if ($scope.selectedImageLevelHypervisorType === HYPERVISOR_HYPERV_HOST && $scope.hyperVTypeApplicationFlag && $scope.imageLevelInstantRecoveryVMOptions.ImageLevelLocationObj == 0) {

            } else if ($scope.selectedImageLevelHypervisorType === HYPERVISOR_HYPERV_HOST) {
                    $scope.restoreObj.target.directory = $scope.imageLevelInstantRecoveryVMOptions.selecteddataStore;
            }

            $scope.restoreObj.backup_id = parseInt(selectedBackup.backup_id, 10);
            // start in audit mode.
            $scope.restoreObj.audit = $scope.imageLevelInstantRecoveryVMOptions.audit;
            if (!$scope.restoreObj.audit && ($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED)) {
                $scope.restoreObj.target.switch = $scope.imageLevelInstantRecoveryVMOptions.network_switch;
            }
            if ($scope.selectedImageLevelHypervisorType !== HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED) {
                $scope.restoreObj.address = $scope.imageLevelInstantRecoveryVMOptions.selectedNetwork;
            }
            return $scope.restoreObj;
        };

        $scope.showToolTipForAuditMode = function(){
            var form = angular.element("#image-level-instant-recovery-location-form");
            console.log(form)
            form.find(".definition").popover({
                appendTo: form
            });
        }
    }]);
