var MINPERCENT = 0.00001;
var MINPERCENT_RATIO = 0.06;
var LARGE_COUNT = 800;
var barWidth ;

function formatMBToGB(input)
{
    var str = PHD.util.formatMB(input);
    var split_value = str.split(" ");
    if (split_value[1] === 'GB') {
        return split_value[0];
    } else {
        return (input/1024).toFixed(4);
    }
}

function formatArray(arr)
{
    var str = "";
    var separator ='';
    var addNewLine = false;
    var len = arr.length;
    if (len !== undefined) {
        for (var i = 0; i < len; i++) {
            var obj = arr[i];
            if (typeof obj === 'string') {
            if(i !== 0){
                separator = ",";
            }
                str = str.trim() + separator+ obj.trim();
            } else {
                addNewLine = true;
                // If the array elements are not strings, format each property.
                var sep = "";
                for (var p in obj) {
                    if (obj.hasOwnProperty(p)) {
                        str += sep + p + ':' + obj[p];
                        sep = ", ";
                    }
                }
            }
            if (addNewLine) {
                str += '\n';
            }
        }
    }
    return str;

}

reportApp.filter('nullTestFilter', function($filter) {
  return function(input) {

    if ( input === undefined || input == null || input =="")
    {
    if(input===false){
        return false;
    }else if(parseInt(input) !== 0){
        return '--';
    }else{
        return input;
    }
    }
    else if ( input instanceof Array)
    {
    return input.toString();
    }
    else
    {
    return input;
    }

  };
});
reportApp.filter('warnThreshold', function($filter) {
  return function(input) {
    return (input * .75);

  };
});

reportApp.filter('DecimalFormatter', function($filter) {
  return function(input) {
        return ((input === "" || isNaN(input)) ? "--" : input.toFixed(2));
  };
});

reportApp.filter('MBToGBFormater', function($filter) {
    return function(input) {
        return formatMBToGB(input);
    };
});

reportApp.filter('arrayToStringFormatter', function($filter) {
    return function(input) {
        return formatArray(input);
    };
});

reportApp.filter('convertMBtoGBFilter', function($filter) {
    return function(input) {
        return (input/1024).toFixed(2);

    };
});
reportApp.filter('colHoldDayFilter', function($filter) {
    return function(input) {
        return (isNaN(input) ? input : parseInt(input));
    };
});
reportApp.filter('severityFilter', function($filter) {
    return function(input) {
        var value = parseInt(input);
        return (value === 1 ? "Fatal" : (value === 2 ? "Warning" : "Notice"));
    };
});
reportApp.filter('statusFilter', function($filter) {
    return function(input) {
        var value = parseInt(input);
        return (value === 0 ? "Closed" : "Open");
    };
});
reportApp.filter('successFilter', function($filter) {
    return function(input) {
        var value;
        if (input === true) {
            value = "Success";
        } else if (input === false) {
            value = "Failure";
        } else {
            value = "Unknown";
        }
        return (value);
    };
});

var failureReportTemplete = "<div ng-click=\"grid.appScope.showFailureBackupInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";

var recoveryHistoryTemplete = "<div ng-click=\"grid.appScope.showRecoveryHistoryInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";

var replicaHistoryTemplate = "<div ng-click=\"grid.appScope.showReplicaHistoryInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";

var recoveryAssuranceTemplate = "<div ng-click=\"grid.appScope.showRecoveryAssuranceInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";

var complianceReportTemplate = "<div ng-click=\"grid.appScope.showComplianceReportInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";

var backupHistoryTemplate = "<div ng-click=\"grid.appScope.showBackupHistoryInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";

var coldBackupCopyHistoryTemplate = "<div ng-click=\"grid.appScope.showColdBackupCopyHistoryInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";

var replicationHistoryTemplate = "<div ng-click=\"grid.appScope.showReplicationHistoryInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";

var applianceUpdateHistoryTemplete = "<div ng-click=\"grid.appScope.showUpdateHistoryInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell ng-style=\"(row.entity.error_count > 0) && {'cursor':'pointer'}\"></div>";

var policiesTemplate = "<div ng-click=\"grid.appScope.showProtectionPolicy(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";

var LTRRetentionTemplate = "<div ng-click=\"grid.appScope.showLTRRetentionInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";

var notificationTemplate = "<div ng-click=\"grid.appScope.showNotificationInfo(row)\" ng-repeat=\"(colRenderIndex, col) in colContainer.renderedColumns track by col.colDef.name\" class=\"ui-grid-cell\" ng-class=\"{ 'ui-grid-row-header-cell': col.isRowHeader }\" ui-grid-cell style=\"cursor:pointer;\"></div>";


/*'<div  ng-dblclick="onDblClickRow()" ng-bind="row.getProperty(col.field)"></div>'*/

/*
        This Function Returns config for each Report
        1. URL for rest API,
        2. Graph/Chart Function Name if Any
        3.Table heading
        4.Column Definition Array for grids.
        Note: Need to create function for column definition for each report
            e.g. createProtectionSummaryColDefArray()
*/
function getReportConfigs($scope, reportId,isCe){
    reportID = parseInt(reportId);
    var returnParams=[];
    var columnDefArray = [];

    switch (reportID) {
        case $scope.LEGAL_HOLD:
            returnParams = ['/api/reports/backup/legal_hold/',"NoChart",[""]];
            break;
        case $scope.PROTECTION_SUMMARY:
            if(!$scope.isCE){
                returnParams = ['/api/reports/protection_summary/',"PieChart",["Assets","Backup"]];
            } else {
                returnParams = ['/api/reports/protection_summary/',"PieChart",["Assets","Backup"]];
            }
            break;
        case $scope.BACKUP_HISTORY:
            returnParams = ['/api/reports/backup/history/',"NoChart",[""]];
            break;
        case $scope.STORAGE_DETAILS:
            returnParams = ['/api/reports/storage/status/',"Pie-BarChart",[""]];
            break;
        case $scope.UPDATES:
            returnParams = ['/api/reports/system/update_history/',"NoChart",[""]];
            break;
        case $scope.REPLICATION:
            returnParams = ['/api/reports/replication/capacity/',"NoChart",[""]];
            break;
        case $scope.ARCHIVE:
            returnParams = ['/api/reports/archive/history/',"NoChart",[""]];
            break;
        case $scope.REPLICATION_HISTORY:
            returnParams = ['/api/reports/replication/history/',"NoChart", ["Backup Copies - Source Status","Backup Copies - Target Status"]];
            break;
        case $scope.ARCHIVE_HISTORY:
            returnParams = ['app/reports/data/protectionSummary.json',"NoChart"];
            break;
        case $scope.VM_STORAGE:
            returnParams = ['app/reports/data/protectionSummary.json',"NoChart"];
            break;
        case $scope.SYSTEM_LOAD:
            returnParams = ['/api/reports/system/load_history/',"Bar-Line",[""]];
            break;
        case $scope.REPLICATION_REPORT:
            returnParams = ['/api/reports/replication/activity/',"NoGrid",[""]];
            break;
        case $scope.RESTORE_HISTORY:
            returnParams = ['/api/reports/restore/history/',"NoChart",[""]];
            break;
        case $scope.RECOVERY_ASSURANCE:
            returnParams = ['/api/reports/recovery_assurance/',"Pie-RDRAssuranceChart",[""]];
            break;
        case $scope.STORAGE_DATAREDUCTION:
            returnParams = ['/api/reports/storage/data_reduction/',"Bar-Line",[""]];
            break;
        case $scope.SYSTEM_CAPACITY:
            returnParams = ['/api/reports/system/capacity/',"NoChart",["Protected Assets"]];
            break;
        case $scope.REPLICATION_FOOTPRINT:
            returnParams = ['/api/reports/replication_footprint/',"NoChart",[""]];
            break;
        case $scope.BACKUP_FAILURE:
            returnParams = ['/api/reports/backup/failure/',"NoChart",[""]];
            break;
        case $scope.ALERT_REPORT:
            returnParams = ['/api/reports/system/alerts/',"NoChart",[""]];
            break;
        case $scope.AUDIT_REPORT:
            returnParams = ['/api/reports/system/notifications/',"NoChart",[""]];
            break;
        case $scope.TRAPS_REPORT:
            returnParams = ['/api/reports/system/trap_history/',"NoChart",[""]];
            break;
        case $scope.WEEKLY_STATUS:
            returnParams = ['/api/reports/backup/status/',"NoChart",[""]];
            break;
        case $scope.DISTRIBUTED_APPLIANCE_CAPACITY:
            returnParams = ['/portal/api/protected.php?type=report',"Line-Graph",[""]];
            break;
        case $scope.APPLIANCE_CUSTOMER_LOCATION:
            returnParams = ['/portal/api/managers.php?level=devices&type=report',"NoChart",[""]];
            break;
        case $scope.DCA_COMPLIANCE_REPORT:
            returnParams = ['/api/reports/compliance/',"Pie-RDRComplianceChart",[""]];
            break;
        case $scope.PROTECTION_POLICIES:
            returnParams = ['/api/reports/backup/policies/',"NoChart",[""]];
            break;
        case $scope.REPLICAS_HISTORY:
            returnParams = ['/api/reports/restore/history/?type=replica',"NoChart",[""]];
            break;
        case $scope.LONG_TERM_RETENTION:
            returnParams = ['/api/reports/retention/ltr/', "NoChart", [""]];
            break;
        case $scope.MINMAX_RETENTION:
            returnParams = ['/api/reports/retention/minmax/', "NoChart", [""]];
            break;
    }
    returnParams.push(columnDefArray);
    return 	returnParams;
}

/*
  This Function createPiechart and append to the divId passed
  as param.
* holderId: DivId
* title: PieChart title
* dataPointsArray: reportDataArray
* colorsArray: Color of Piechart
* legendArray: Legend of Piechart
*/
function createpieChart(holderId, title, dataPointsArray, colorsArray, legendArray) {
    //console.log(holderId,title,dataPointsArray,colorsArray,legendArray);
    var r = Raphael(holderId);
    var pie = r.piechart(120, 130, 100, dataPointsArray, {minPercent:MINPERCENT, colors: colorsArray, legend: legendArray, legendpos: "south"});

    r.text(140, 10, title).attr({ font: "1.5em sans-serif" });

    function resizeBounce(s) {
        s.sector.animate({ transform: 's1 1 ' + s.cx + ' ' + s.cy }, 500, "bounce");
    }

    pie.hover(function () {
        this.sector.stop();
        this.sector.scale(1.1, 1.1, this.cx, this.cy);
        // Go back to regular size after 500 ms
        setTimeout(resizeBounce, 500, this);

        if (this.label) {
            this.label[0].stop();
            this.label[0].attr({ r: 7.5 });
            this.label[1].attr({ "font-weight": 800 });
        }
    }, function () {
        // Go back to regular size.
        resizeBounce(this);

        if (this.label) {
            this.label[0].animate({ r: 5 }, 500, "bounce");
            this.label[1].attr({ "font-weight": 400 });
        }
    });
}

// This is a custom sort function to sort date strings in reports.
function sortDates(d1, d2) {
    return Date.parse(d1) - Date.parse(d2);
}

/*
 * Use moment's locale specifiers to return the current date and time.
 */
function getCurrentTimeAndDate(){
    var timeOfDay = moment().format("LTS");
    var currentDate = moment().format("LL");
    return currentDate + " " + timeOfDay;
}

/*
 * WARNING: This is a one-off, used for Backup Copy Cold (Archive) History column definitions.
 */
var coldTarget = {
    "system_name": "string",
    "app_name":"string",
    "archive_time":"string",
    "elapsed_time":"string",
    "client_name":"string",
    "instance_description":"string",
    "backup_time":"string",
    "type":"string",
    "compressed":"string",
    "description":"string",
    "target":"string",
    "deduped":"string",
    "encrypted":"string",
    "serials":"string",
    "label":"string",
    "barcodes":"string",
    "retention_days":"string",
    "success": "boolean",
    "size": "long"
};

/*This Function manipulates data send by restAPI for creating Pie chart.
 * resultData: Json Data
*/
function pieChartColorMaker(result)
{
    var colorsList=[];
    var colorSet=["#da3b3c", "#6eb43f", "#e38962", "#3e6c90"]
    var colors=[];

    var sorted = result.slice(0).sort(function(b, a) {
        return a.value - b.value;
    });

    var keys = [];
    for (var i = 0, len = sorted.length; i < len; ++i) {
        keys[i] = sorted[i].key;
    }

    if ( result.length == 4 && result[0].value == 0 && result[1].value == 0 && result[2].value == 0 && result[3].value == 0)
    {
        colorsList.push('#d3d3d3');
        colorsList.push('#d3d3d3');
        colorsList.push('#d3d3d3');
        colorsList.push('#d3d3d3');
    }
    else if ( result.length == 3 && result[0].value == 0 && result[1].value == 0 && result[2].value == 0)
    {
        colorsList.push('#d3d3d3');
        colorsList.push('#d3d3d3');
        colorsList.push('#d3d3d3');
    }
    else if ( result.length == 2 && result[0].value == 0 && result[1].value == 0)
    {
        colorsList.push('#d3d3d3');
        colorsList.push('#d3d3d3');
    }
    else if ( (result.length == 3 || result.length == 2) && result[0].value == result[1].value )
    {
        colorsList.push(colorSet[1]);
        colorsList.push(colorSet[0]);
        colorsList.push(colorSet[2]);
    }
    else
    {
        for (i=0; i < keys.length ; i++)
        {
            if (keys[i] == 'success') {
                colorsList.push(colorSet[1]);
            } else if (keys[i] == 'failure') {
                colorsList.push(colorSet[0]);
            } else if (keys[i] == 'alreadyRunning') {
                colorsList.push(colorSet[3]);
            } else {
                colorsList.push(colorSet[2]);
            }
        }
    }
    return colorsList;
}

function pieChartColorMakerForStorage(result)
{
    var colorsList=[];
    var colorSet=["#6eb43f","#da3b3c"];
    var colors=[];

    var sorted = result.slice(0).sort(function(b, a) {
        return (a.value - b.value);
    });

    var keys = [];
    for (var i = 0, len = sorted.length; i < len; ++i) {
        keys[i] = sorted[i].key;
    }

    for (i=0; i < keys.length ; i++)
    {
        if (keys[i] == 'FreeStorage') {
            colorsList.push(colorSet[0]);
        } else {
            colorsList.push(colorSet[1]);
        }
    }
    return colorsList;
}

function PieChartRenderProtSummary(resultData, isCE, gettextCatalog){
    console.log(resultData);

    function calcMinPercent(count) {
        if (count > LARGE_COUNT) {
            return MINPERCENT_RATIO / count;
        } else {
            return MINPERCENT;
        }
    }

    var colorlist=[];

    var titleList =[];
    var titles=[];
    var title="";
    var calcSum;
    var dataPointslist=[];
    var dataPoints=[];
    var legendList=[];
    var legends=[];
    var legend;
    var dataPointValue;
    var dataPointValueSuccess;

    var protectedAssets = parseInt(resultData.data.data.protected_assets);
    var unProtectedAssets = (parseInt(resultData.data.data.unprotected_assets));

    calcSum = parseInt(protectedAssets)+ parseInt(unProtectedAssets);
    var minPercent = calcMinPercent(calcSum);
    dataPointValue = (unProtectedAssets > 0) ? unProtectedAssets : minPercent;
    dataPoints.push(dataPointValue);
    dataPointValueSuccess= (protectedAssets > 0) ? protectedAssets : minPercent;
    dataPoints.push(dataPointValueSuccess);
    dataPointslist.push(dataPoints);
    title= gettextCatalog.getString("Total Assets") + " (" + calcSum + ")";
    titles.push(title);
    titleList.push(titles);
    legend = gettextCatalog.getString("Unprotected Assets") + "  (" +unProtectedAssets + ")";
    legends.push(legend);
    legend = gettextCatalog.getString("Protected Assets") + " (" +protectedAssets +  ")";
    legends.push(legend);
    legendList.push(legends);
    var result = [
        {key: "success", value: protectedAssets},
        {key: "failure", value: unProtectedAssets}
    ];
    colorlist.push(pieChartColorMaker(result));
    /******************* protected and not protected backup copy ******************/

    var protectedBackupCopy = (parseInt(resultData.data.data.assets_protected_by_backup_copy));
    var notProtectedBackupCopy = (parseInt(resultData.data.data.assets_not_protected_by_backup_copy));

    dataPoints=[];
    title="";
    titles=[];
    legends=[];

    calcSum = parseInt(protectedBackupCopy)+ parseInt(notProtectedBackupCopy);
    minPercent = calcMinPercent(calcSum);
    dataPointValue = (protectedBackupCopy > 0) ? protectedBackupCopy : minPercent;
    dataPoints.push(dataPointValue);
    dataPointValueSuccess= (notProtectedBackupCopy > 0) ? notProtectedBackupCopy : minPercent;
    dataPoints.push(dataPointValueSuccess);
    dataPointslist.push(dataPoints);
    title= gettextCatalog.getString("Total Assets Copied") + " (" + calcSum + ")";
    titles.push(title);
    titleList.push(titles);
    legend  = gettextCatalog.getString("Protected Backup Copy") + "  (" +protectedBackupCopy + ")";
    legends.push(legend);
    legend = gettextCatalog.getString("Not Protected Backup Copy") + " (" +notProtectedBackupCopy +  ")";
    legends.push(legend);
    legendList.push(legends);
    var result = [
        {key: "success", value: protectedBackupCopy},
        {key: "failure", value: notProtectedBackupCopy}
    ];
    colorlist.push(pieChartColorMaker(result));

    /******************* Backups ******************/
    dataPoints=[];
    title="";
    titles=[];
    legends=[];
    var backupSuccess = (parseInt(resultData.data.data.backups.successes));
    var backupWarnings = (parseInt(resultData.data.data.backups.warnings));
    var backupFailures = (parseInt(resultData.data.data.backups.failures));

    calcSum = (backupSuccess + backupWarnings + backupFailures);
    minPercent = calcMinPercent(calcSum);
    dataPointValue = (backupSuccess > 0) ? backupSuccess : minPercent;
    dataPoints.push(dataPointValue);
    dataPointValueSuccess = (backupFailures > 0) ? backupFailures : minPercent;
    dataPoints.push(dataPointValueSuccess);
    dataPointValueSuccess= (backupWarnings > 0) ? backupWarnings : minPercent;
    dataPoints.push(dataPointValueSuccess);
    dataPointslist.push(dataPoints);

    title= gettextCatalog.getString("Total Backups") + " (" + calcSum + ")";
    titles.push(title);
    titleList.push(titles);

    legend  = gettextCatalog.getString("Success") + "  (" +backupSuccess + ")";
    legends.push(legend);

    legend = gettextCatalog.getString("Failure") + " (" +backupFailures +  ")";
    legends.push(legend);

    legend =gettextCatalog.getString("Warnings") + " (" +backupWarnings +  ")";
    legends.push(legend);

    legendList.push(legends);
    var result = [
        {key: "success", value: backupSuccess},
        {key: "failure", value: backupFailures},
        {key: "warning", value: backupWarnings}
    ];
    colorlist.push(pieChartColorMaker(result));
    /******************* Backups Copies ******************/

    console.log("Success >> "+resultData.data.data.backup_copies.successes);
    console.log("failure >> "+resultData.data.data.backup_copies.failures);

    var backupCopiesSuccess = parseInt(resultData.data.data.backup_copies.successes);
    var backupCopiesFailure = parseInt(resultData.data.data.backup_copies.failures);

    dataPoints=[];
    title="";
    titles=[];
    legends=[];

    calcSum = parseInt(backupCopiesSuccess)+ parseInt(backupCopiesFailure);
    minPercent = calcMinPercent(calcSum);
    dataPointValue = (backupCopiesSuccess > 0) ? backupCopiesSuccess : minPercent;
    dataPoints.push(dataPointValue);
    dataPointValueSuccess= (backupCopiesFailure > 0) ? backupCopiesFailure : minPercent;
    dataPoints.push(dataPointValueSuccess);
    dataPointslist.push(dataPoints);

    title= gettextCatalog.getString("Total Backups Copied") + " (" + calcSum + ")";
    titles.push(title);
    titleList.push(titles);

    legend  = gettextCatalog.getString("Success") + "  (" +backupCopiesSuccess + ")";
    legends.push(legend);
    legend = gettextCatalog.getString("Failure") + " (" +backupCopiesFailure +  ")";
    legends.push(legend);
    legendList.push(legends);

    var result = [
        {key: "success", value: backupCopiesSuccess},
        {key: "failure", value: backupCopiesFailure}
    ];
    colorlist.push(pieChartColorMaker(result));
    /******************* Backups Copies Target ******************/

    var backupObj = resultData.data.data.backup_copies.assets;
    for(key in backupObj){

        var successTarget  = backupObj[key].successes;
        var failureTarget  = backupObj[key].failures;
        var assetTarget    = backupObj[key].target;

        dataPoints=[];
        title="";
        titles=[];
        legends=[];

        calcSum = parseInt(successTarget)+ parseInt(failureTarget);
        minPercent = calcMinPercent(calcSum);
        dataPointValue = (successTarget > 0) ? successTarget : minPercent;
        dataPoints.push(dataPointValue);
        dataPointValueSuccess= (failureTarget > 0) ? failureTarget : minPercent;
        dataPoints.push(dataPointValueSuccess);
        dataPointslist.push(dataPoints);

        title= gettextCatalog.getString("Backups Copies") + " (" +assetTarget+" "+ calcSum + ")";
        titles.push(title);
        titleList.push(titles);

        legend  = gettextCatalog.getString("Success") + " (" +successTarget + ")";
        legends.push(legend);
        legend = gettextCatalog.getString("Failure") + " (" +failureTarget +  ")";
        legends.push(legend);
        legendList.push(legends);

        var result = [
            {key: "success", value: successTarget},
            {key: "failure", value: failureTarget}
        ];
        colorlist.push(pieChartColorMaker(result));
    }
    /***************************************/
    var holderIDBackup=$("#flot_holder");

    for (var i = 0; i < titleList.length; ++i){
        newId = "pie-chart-holder" + i;
        if(!isCE){
            if(i === 4){
                holderIDBackup.append('<div style="clear:both;"></div>');
            }
            holderIDBackup.append('<div id="' + newId + '" class="pie-chart-container"></div>');
        }else{
            if(i === 4){
                holderIDBackup.append('<div style="clear:both;"></div>');
            }
            holderIDBackup.append('<div id="' + newId + '" class="pie-chart-container-isCE"></div>');
        }
        createpieChart(newId, titleList[i], dataPointslist[i], colorlist[i], legendList[i]);
    }
}

/* For creating Bar chart Data*/
function createBarChartData(result, gettextCatalog, barClass, sizeClassString, widthPixels, yOffsetPixels, titleString, heightPixels, titleOutside){
    //console.log(result.data.data);
    var chartTitle = titleString || gettextCatalog.getString("Backup Storage Usage") + " (" + gettextCatalog.getString("does not include backup copy targets") + ")";
    var chartClass = barClass || "report-storage-barchart";
    var sizeClass = sizeClassString || "graph-container-huge";
    var chartWidth = widthPixels || 900;
    var yOffset = yOffsetPixels || 50;
    var chartHeight = heightPixels || 240;
    var titleOutsideGraph = titleOutside || false;
    var griddata = result.data.data;
    var tempValFreeSpaceArray = [];
    var tempValUsedSpaceArray = [];
    var tempvalueArray = [];
    var dateArray=[];
    var barTitleList=[];
    var tooltipArray = [ ];
    var colorArray = 	[
        null,
        null,
        null
    ];
    var barTitle =	["Storage Totals (98.4 GB)"];
    for(var j=0;j<griddata[0].size_history.length;j++){
        var freeSpace = 0;
        var usedSpace = 0;
        var day = '';
        for(var k=0;k<griddata.length;k++){
            var usedSize = griddata[k].size_history[j].mb_used;
            var freeSize = griddata[k].size_history[j].mb_free;
            // day is returned from API as YYYY-MM-DD, convert to locale (M/D/Y) or (D/M/Y).
            day = dateAxisLabel(griddata[k].size_history[j].day, true);
            freeSpace += (freeSize / 1024);
            usedSpace += (usedSize / 1024);
        }
        tempValFreeSpaceArray.push(parseFloat(freeSpace.toFixed(1)));
        tempValUsedSpaceArray.push(parseFloat(usedSpace.toFixed(1)));
        tooltipArray.push(freeSpace.toFixed(1)+"GB free\n"+usedSpace.toFixed(1)+"GB used");
        dateArray.push(day);

    }
    tempvalueArray.push(tempValUsedSpaceArray);
    tempvalueArray.push(tempValFreeSpaceArray);

    barTitleList.push(barTitle);
    holderID=$("#flot_holder");
    if (titleOutsideGraph) {
        // optionally move the chart title into the chart area itself, so that it will stay with the chart on resize.
        holderID.append('<div class="' + chartClass + '">' + chartTitle + '</div>');
    }
    for (var i = 0; i < barTitleList.length; ++i){
        newId = "backup-graph" + i;
        holderID.append('<div id="' + newId + '" class="' + sizeClass +
            '"><div class="bar-chart-legend"><div class="chart-free-space"><div></div>' +
            gettextCatalog.getString("Free Storage") +
            '</div><div class="chart-used-space"><div></div>' +
            gettextCatalog.getString("Used Storage") +
            '</div></div></div>');
        buildBarChart(newId, tempvalueArray, tooltipArray, dateArray, colorArray, chartWidth, yOffset, chartTitle, chartHeight, titleOutsideGraph);
    }
}

function PieChartForBackupStorage(result, gettextCatalog){

    var dataPoints=[];
    var title="";
    var titles=[];
    var calcSum=0;
    var legends=[];
    var dataPointValue1;
    var dataPointValue2;
    var dataPointslist =[];
    var legendList=[];
    var colorlist=[];
    var titleList =[];

    var freeData =  0;
    var availData = 0;

    for(var i=0; i<result.data.data.length;i++){
        freeData +=  (result.data.data[i].mb_free);
        availData += (result.data.data[i].mb_used);
    }

    dataPointValue1= (freeData > 0) ? freeData : MINPERCENT;
    dataPoints.push(dataPointValue1);
    dataPointValue2= (availData > 0) ? availData : MINPERCENT;
    dataPoints.push(dataPointValue2);
    dataPointslist.push(dataPoints);

    legend = gettextCatalog.getString("Free Storage") + " (" +formatMBToGB(freeData) +  " GB)";
    legends.push(legend);
    legend  = gettextCatalog.getString("Used Storage") + " (" +formatMBToGB(availData) + " GB)";
    legends.push(legend);
    legendList.push(legends);

    var result = [
        {key: "FreeStorage", value:freeData},
        {key: "UsedStorage", value: availData}
    ];
    colorlist.push(pieChartColorMakerForStorage(result));
    calcSum = parseFloat(freeData + availData);
    title= gettextCatalog.getString("Storage Totals") + " (" + formatMBToGB(calcSum) + " GB)";
    titles.push(title);
    titleList.push(titles);

    holderID=$("#flot_holder");

    for (i = 0; i < titleList.length; ++i){
        newId = "pie-chart-holder" + i;
        holderID.append('<div id="' + newId + '" class="pie-chart-container"></div>');
        createpieChart(newId, titleList[i], dataPointslist[i], colorlist[i], legendList[i]);
    }

}

function labelBarChart(r, bc, labels, attrs) {
    // Label a bar chart bc that is part of a Raphael object r
    // Labels is an array of strings. Attrs is a dictionary
    // that provides attributes such as fill (text color)
    // and font (text font, font-size, font-weight, etc) for the
    // label text.
    for (var i = 0; i < bc.bars[0].length; i++) {
        var bar = bc.bars[0][i];
        var gutter_y = bar.w * 0.4;
        var label_x = bar.x;
        var label_y = bar.y + bar.h + gutter_y;
        var label_text = labels[i];

        r.text(label_x, label_y, label_text).attr(attrs);
    }
}

function buildBarChart(target, values, tooltips, dates, colorOverrides, chartWidth, yOffset, chartTitle, chartHeight, titleOutside) {
    var barDelta = chartWidth == 800 ? 24 : 27;
    var firstBar = chartWidth == 800 ? 46 : 58;
    var titleOutsideChart = titleOutside || false;
    var options = { width: chartWidth, height: chartHeight, y_offset: yOffset },
        overrideColor,
        barOver = function () {
            var y = [];
            for (var i = this.bars.length; i--;) {
                y.push(this.bars[i].y);
            }
            this.flag = r.popup(this.bars[0].x, Math.min.apply(Math, y), tooltips[parseInt((this.bars[0].x - firstBar) /  barDelta)]).insertBefore(this);
        },
        barOut = function () {
            this.flag.animate({opacity: 0}, 300, function () {this.remove();});
        };
    var r = Raphael(target, options.width, options.height);
    if (!titleOutsideChart) {
        var txtattr = { font: "1.5em sans-serif" };
        r.text(420, 20, chartTitle).attr(txtattr);      // center the title.
    }

    var bc = r.barchart(42, options.y_offset, options.width - 72, options.height - options.y_offset, values, { stacked:true, type:'soft', colors:['#80bc3d', '#ccc'] }).hoverColumn(barOver, barOut);
    $("    #" + target + " svg path").each(function(index) {
        if (index % 2 == 1) {
            overrideColor = colorOverrides[parseInt(index / 2)];
            if (overrideColor) {
                $(this).attr("fill", overrideColor);
            }
        }
    });

    labelBarChart(r, bc, dates, { fill: "black", font: "8px sans-serif" } );

    return bc;
}
/*Adding function for Data reduction*/

/* function to calculate the width of
 * barChart based on the no. of bars we
 * need to show in the Barchart
 */
function barChartWidthAssigner(datalength)
{
    var barchartWidth=(datalength*35);

    if (barchartWidth <= 1500)
    {
        return barchartWidth;
    }
    else
    {
        var svgWidth= (barchartWidth+350)+"px";
        console.log(svgWidth);
        $('#flot_holder').css("width",svgWidth);
        $('#bar-chart-container').css("width",svgWidth);
        return barchartWidth;
    }
}

function labelDataReductionBarChart(r, bc, labels, attrs) {
    // Label a bar chart bc that is part of a Raphael object r
    // Labels is an array of strings. Attrs is a dictionary
    // that provides attributes such as fill (text color)
    // and font (text font, font-size, font-weight, etc) for the
    // label text.

    for (var i = 0; i<bc.bars.length; i++) {
        var bar = bc.bars[i];
        barWidth =bar.w;
        if ((i % 2) === 0)
        {
            var gutter_y = bar.w * 0.4;
            var label_x = bar.x
            var label_y = bar.y + bar.h + gutter_y;
            var label_text = labels[i];
            var label_attr = { fill:  "black", font: "9px sans-serif" };

            r.text(label_x, label_y, label_text).attr(label_attr);
        }
    }
}

/*
 * Create an axis label for the date by using the local format mm/dd/yyyy or dd/mm/yyyy, depending on locale.
 * If stripYear is true, remove the year from the date.
 */
function dateAxisLabel(calcDate, stripYear)
{
    var removeYear = stripYear || false;
    var tzDate = new Date(calcDate);
    // Convert the timezone offset to milliseconds and add.
    var axisDate = tzDate.getTime() + (tzDate.getTimezoneOffset() * 60 * 1000);
    var dateString = moment(axisDate).format("L");
    if (removeYear) {
        dateString = dateString.substring(0, dateString.lastIndexOf('/'));
    }
    return dateString;
}

function lineOverBarDataReduction(resultData, isCE, gettextCatalog, locale) {

    var dateRangeValues=[];
    var deDuplicationValues=[];
    var dataReductionValues=[];
    var barchartWidth = barChartWidthAssigner(resultData.data.length);

    for (i = 0; i < resultData.data.length ; i++) {
        var dateString = resultData.data[i].date;
        var calcDate = DateTimeHandler.getUSDateObject(locale, dateString);
        var dayAxis = dateAxisLabel(calcDate);

        dateRangeValues.push(dayAxis);
        deDuplicationValues.push(resultData.data[i].dedup);
        dataReductionValues.push(resultData.data[i].data_reduction);
    }
    holderID=$("#flot_holder");
    console.log("holderID:::"+holderID);
    holderID.append('<div id="bar-chart-container"> </div>');
    $('#bar-chart-container').css("height","700px");
    //$('#bar-chart-container').css("margin-left","100px")

    var r = Raphael('bar-chart-container');
    //Raphael.g.axis(85,230,100,1,null,4,2,["Today", "Yesterday", "Tomorrow", "Future"], null, 1, r);
    /* params
        1 and 2nd param xaxis and yaxis  co-ordinate from bottom left
        3rd length
        4rth min
        5th max
        6th step
        7th varaint 0,1,2,3
        8th labels
        9th type
        10th dashline ( 1 if needed 0 if didn't)
        11th rapahel object
    */

    //var attr = {font:'12px Verdana', 'text-anchor':'start', 'font-weight':'bold'};

    var attr = {'font-size':'14px', 'font-family':'Verdana', 'text-anchor':'start', 'font-weight':'bold'};
    var legend_attr = {'font-size':'12px', 'font-family':'Verdana', 'text-anchor':'start', 'font-weight':'normal'};

    if (!isCE) {
        var lineMax = deDuplicationValues.length === 0 ? 0.01: Math.max.apply(Math,deDuplicationValues);
        var lineMin = deDuplicationValues.length === 0 ? 0 : Math.min.apply(Math,deDuplicationValues);

        Raphael.g.axis(140, 457, 360, lineMin, lineMax, 30, 1, null, 1, 1, r);
        r.text(-10, 250, gettextCatalog.getString("Deduplication Ratio")).attr(attr).rotate(270);
    }

    var barMaxValue = dataReductionValues.length === 0 ? 0 : Math.max.apply(Math,dataReductionValues);

    if (barMaxValue == 0) { /*assigning minimum values*/
        for (var i = 0; i < dataReductionValues.length ; i++) {
            dataReductionValues[i]=0.01;
        }
        barMaxValue = 0.01;
    }

    var fin = function () {
            var barValue = this.bar.value;
            this.flag = r.popup(this.bar.x, this.bar.y, barValue  || "0").insertBefore(this).attr({stroke:"#fff",fill:"#000"});
        },
        fout = function () {
            this.flag.animate({opacity: 0}, 300, function () {this.remove();});
        };

    var bc = r.barchart(150, 80, barchartWidth, 400, dataReductionValues, {stacked: false,type: "soft"}).hover(fin, fout);
    bc.attr({fill: "#EE8833"});
    labelDataReductionBarChart(r, bc,dateRangeValues,{ fill:  "blue", font: "8px sans-serif" });
    /* Code For Over lapping Line */
    var axisArray=[];
    var stepsForAxis=deDuplicationValues.length;
    for (i=0; i < deDuplicationValues.length ; i++){
        axisArray.push(i);
    }

    var widthOffSet = 0;
    if (deDuplicationValues.length > 15){
        widthOffSet = (deDuplicationValues.length * 0.233);
    }else{
        widthOffSet = -(deDuplicationValues.length * 0.2);
    }

    if (!isCE) {
        var lines = r.linechart((150 + (barWidth/2)), 87, ((barchartWidth-barWidth) + widthOffSet), 380,
            [axisArray,axisArray], [deDuplicationValues],
            { nostroke: false, axis: "0 0 0 0", symbol: "circle", smooth: false, axisystep :6, colors:["#629632"]}).hover(function(){
            var lineValue =this.value;
            this.flag = r.popup(this.x,this.y,lineValue || "0").insertBefore(this).attr({stroke:"#000",fill:"#629632"});
        }, function(){this.flag.animate({opacity: 0}, 300, function () {this.remove();});});

        lines.symbols.attr({ r: 4});
        lines.lines[0].animate({"stroke-width": 4}, 1000);
        lines.symbols[0].attr({stroke: "#2C6700"});
    }

    r.rect(241, 500, 10, 10).attr({fill: '#EE8833',stroke:'#EE8833'});
    r.text(271, 505, gettextCatalog.getString("Data Reduction Ratio")).attr(legend_attr);

    if (!isCE) {
        r.rect(481, 500, 10, 10).attr({fill: '#629632',stroke:'#629632'});
        r.text(511, 505, gettextCatalog.getString("Deduplication Ratio")).attr(legend_attr);
    }

    var lineXAxisValue = 150 + barchartWidth + widthOffSet + 10;
    Raphael.g.axis(lineXAxisValue, 458, 360, 0, barMaxValue, 30, 3, null, 1, 1, r);
    r.text(lineXAxisValue - 40, 243, gettextCatalog.getString("Data Reduction Ratio")).attr(attr).rotate(270);

}

/* Load Chart Code Starts Here*/

/*  function scaling Formula:
Old range       New Range
 [min ,max]   to   [a ,b]
 f(x) = [ ( (a-b) ( x-min) / (max -min) ) + a ]
 */
function scalingFormula(oldMin,oldMax,newMin,newMax,value)
{
    return (((newMax - newMin) * (value - oldMin))/(oldMax -oldMin)) + newMin;
}

/*
* Scale data will scaleUp or scaleDown data for new Yaxis range i.e. warningThreshold,overloadThreshold,errorThreshold and maxYvalue
*/
function scaleDataforLoad(data , warningThreshold,overloadThreshold,errorThreshold,maxYvalue )
{
    var yAxisData;
    var scaledDataArray=[];
    var newMin;
    var newMax;
    var oldMin;
    var oldMax;

    for (i =0 ; i < data.length ; i++)
    {
        if (data[i] <= warningThreshold )
        {
            oldMin = 0;
            oldMax = warningThreshold;
            newMin = 0;
            newMax = 2.3;
            yAxisData=scalingFormula(oldMin,oldMax,newMin,newMax,data[i]);
        }
        else if ( data[i] <= overloadThreshold )
        {
            oldMin = warningThreshold;
            oldMax = overloadThreshold;
            newMin = 2.3;
            newMax = 4.7;
            yAxisData=scalingFormula(oldMin,oldMax,newMin,newMax,data[i]);

        }
        else if (data[i] > overloadThreshold)
        {
            oldMin = overloadThreshold;
            oldMax = maxYvalue;
            newMin = 4.7;
            newMax = 7;
            yAxisData = scalingFormula(oldMin,oldMax,newMin,newMax,data[i]);

        }
        else{
            yAxisData=data[i];
        }
        scaledDataArray.push(yAxisData);
    }
    return scaledDataArray;
}

/*
    Plots line graph for a particular system load on three horizontal bar
    denoting normal, warning, and error state.

*/
function plotSystemLoadGraph(resultdata, start_date_val, end_date_val, gettextCatalog)
{
    var xAxisValuse=[];
    var yAxisValues=[];
    var yAxisScalevalue=[];
    var overloadThreshold=125;
    var warningThreshold=125;
    var overload=resultdata.overload_threshold;
    var warning=resultdata.warning_threshold;
    var error=(overload-warning)+overload;
    var errorThreshold=((overloadThreshold - warningThreshold) + overloadThreshold);
    for (i =0 ; i < resultdata.data.length ; i++)
    {
        var dateInMili= resultdata.data[i].day +" " + resultdata.data[i].time;
        var d = new Date(dateInMili);
        xAxisValuse.push(d.getTime());
        yAxisScalevalue.push(resultdata.data[i].load);
    }
    maxYvalue = Math.max.apply(Math,yAxisScalevalue);
    yAxisValues=  scaleDataforLoad(yAxisScalevalue,warning,overload,error,maxYvalue);

    holderID=$("#flot_holder");
    //$holderID.removeClass("hidden");
    holderID.append('<div id="bar-chart-container"> </div>');
    $('#bar-chart-container').css("height","700px");
    $('#bar-chart-container').css("margin-left","100px")

    var r = Raphael('bar-chart-container');
    var maxValue = Math.max.apply(Math,yAxisValues) * 50;
    //4rth Param height of HBARoverloadThreshold
    var overLoadChart = r.hbarchart(100, 400, 1200, warningThreshold, [[500]],{stacked: false, colors:["rgb(149,175,149)"], "gutter":"0%"});

    var warningChart =r.hbarchart(100, 400-overloadThreshold, 1200, overloadThreshold, [[500]],{stacked: false, colors:["rgb(200,200,149)"], "gutter":"0%"});

    var errorChart =r.hbarchart(100, 400 -(overloadThreshold +errorThreshold), 1200, errorThreshold, [[500]],{stacked: false, colors:["rgb(200,149,149)"], "gutter":"0%"});


    var x = 80;
    var y = 400 -(overloadThreshold +errorThreshold);
    var xlen = 900;
    var ylen =  errorThreshold + 288;
    var gutter = 20;
    var xdata = [0, 2, 4,6];

    /* two lines are drawn first tranparent line to provide the access to Horizontal bar from 0,7
    and second one denoting the system load*/
    var loadChart = r.linechart(80, y-19, 1240, ylen, [xAxisValuse ,xAxisValuse], [[0,1,2,7],yAxisValues], {
        gutter   : gutter,
        nostroke : false,
        axis     : "0 0 1 0",
        smooth   : false,
        shade    : true,
        colors   : ["transparent","blue"]
    });
    /*adding labels for differnt levels */
    r.text(670, 100, gettextCatalog.getString("Appliance Load")).attr({ font: "1.5em sans-serif" ,"font-weight": "bold" });

    r.rect(660, ylen + 190, 8,14).attr({fill: 'rgb(0,0,255)',stroke:'rgb(0,0,255)'});
    r.text(720, ylen + 198, gettextCatalog.getString("Load Level")).attr({ font: "1.2em sans-serif" ,"font-weight": "bold" });

    var idealLoadTooltip =  gettextCatalog.getString("Load level below") + " " + warning;
    var warningLoadTooltip = gettextCatalog.getString("Load level between") + " " + warning + " " + gettextCatalog.getString("and") + " " + overload;
    var overLoadedTooltip = gettextCatalog.getString("Load level over") + " " + overload;
    var attr = {font:'12px sans-serif','text-anchor':'end', 'font-weight': 'bold'};
    var xdata = 87;
    r.text( xdata, 460, gettextCatalog.getString("Ideal Range")).attr(attr).attr({"title": idealLoadTooltip});
    r.text( xdata, 340, gettextCatalog.getString("Warning Range")).attr(attr).attr({"title": warningLoadTooltip});
    r.text( xdata, 220, gettextCatalog.getString("Alarm Range")).attr(attr).attr({"title": overLoadedTooltip});
    loadChart.shades[1].attr({ opacity: 1 });
    var axisItems = loadChart.axis[0].text.items;

    if (axisItems.length > 0) {
        var axisText = "";
        // Nothing on point (0,0)
        axisItems[0].attr("text",axisText);
        // If only one day, show time, not day.
        var showTimeOfDay = (start_date_val === end_date_val);
        for(var i = 1; i < axisItems.length; i++ ) {
            var date = new Date(parseInt(axisItems[i].attr("text")));
            var timeOfDay = moment(date).format("LT");
            if (showTimeOfDay) {
                axisText = timeOfDay;
            } else {
                var formatL = moment.localeData().longDateFormat('L');
                var formatYearLessL = formatL.replace(/[^MD]*YYYY[^MD]*?(?=M|$| [Hh])/, '');
                var formatDate = moment(date).format(formatYearLessL);
                axisText = formatDate + " " + timeOfDay;
            }
            axisItems[i].attr("text",axisText).rotate(45).attr({'text-anchor':'start'});
        }
    }
}

function createRDRCharts(data, isCE, gettextCatalog)
{
  //console.log("createRDRCharts : data - " + data);

  var colorlist =[];
  var titleList=[];
  var dataList=[];
  var legend;
  var legends=[];
  var legendList=[];
  var result = [ {key: "success", value: data.successes},
    {key: "failure", value: data.failures},
    {key: "warning", value: data.warnings},
        {key: "alreadyRunning", value: data.alreadyRunning}
  ];
  colorlist.push(pieChartColorMaker(result));

    legend = gettextCatalog.getString("Success") + " (" +data.successes +  ")";
    legends.push(legend);
  legend = gettextCatalog.getString("Failure") + " (" +data.failures + ")";
  legends.push(legend);
  legend = gettextCatalog.getString("Warning") + " (" + data.warnings + ")";
  legends.push(legend);
    legend = gettextCatalog.getString("Already Running") + " (" + data.alreadyRunning + ")";
    legends.push(legend);
  legendList.push(legends);
    var successes = data.successes > 0 ? data.successes : MINPERCENT;
    var failures =  data.failures > 0 ? data.failures : MINPERCENT;
    var warnings = data.warnings > 0 ? data.warnings : MINPERCENT;
    var alreadyRunning = data.alreadyRunning > 0 ? data.alreadyRunning : MINPERCENT;
  var dataArray = [successes, failures, warnings, alreadyRunning];
  dataList.push(dataArray);
  var title = gettextCatalog.getString("Results");
  titleList.push(title);

  holderID = $("#flot_holder");

  for (var i =0 ; i <titleList.length ; i++)
  {
    newId = "pie-chart-holder" + i;
    holderID.append('<div id="' + newId + '"  class="recovery-assurance-pie-chart-container"></div>');
    if (i == 0)
    {
    createpieChart(newId, titleList[i], dataList[i], colorlist[i], legendList[i]);
    }
  }
}

function createRDRComplianceCharts(data, isCE, gettextCatalog)
{
    //createPieChart
    //console.log("createRDRComplianceChart: data - ", data);

    var colorlist =[];
    var titleList=[];
    var dataList=[];
    var legend;
    var legends=[];
    var legendList=[];
    var complianceFailure;
    var rpoFailure;
    var rtoFailure;
    if(data.count === 0){
        complianceFailure = data.compliance === 0 ? data.compliance : (100 - data.compliance);
        rpoFailure = data.rpo === 0 ? data.rpo : (100 - data.rpo);
        rtoFailure = data.rto === 0 ? data.rto : (100 - data.rto);
    }
    else{
        complianceFailure = (100 - data.compliance) % 1 == 0 ? (100 - data.compliance) : (100 - data.compliance).toFixed(2);
        rpoFailure = (100 - data.rpo) % 1 == 0 ? (100 - data.rpo) : (100 - data.rpo).toFixed(2);
        rtoFailure = (100 - data.rto) % 1 == 0 ? (100 - data.rto) : (100 - data.rto).toFixed(2);
    }

    var result = [ {key: "success", value: data.compliance},
        {key: "failure", value: complianceFailure}
    ];
    colorlist.push(pieChartColorMaker(result));
    legends = [gettextCatalog.getString("Success") + " (" + data.compliance +  "%)", gettextCatalog.getString("Failure") + " (" + complianceFailure + "%)"];
    legendList.push(legends);
    var successes = data.compliance > 0 ? data.compliance : MINPERCENT;
    var failures = data.count === 0 || successes === 100 ? MINPERCENT : 100 - successes;
    var dataArray = [successes, failures];
    dataList.push(dataArray);
    var title = gettextCatalog.getString("Compliance");
    titleList.push(title);

    var result = [ {key: "success", value: data.rpo},
        {key: "failure", value: rpoFailure}
    ];
    colorlist.push(pieChartColorMaker(result));
    legends = [gettextCatalog.getString("Success") + " (" + data.rpo +  "%)", gettextCatalog.getString("Failure") + " (" + rpoFailure + "%)"];
    legendList.push(legends);
    var successes = data.rpo > 0 ? data.rpo : MINPERCENT;
    var failures =  data.count === 0 || successes === 100 ? MINPERCENT : 100 - successes;
    var dataArray = [successes, failures];
    dataList.push(dataArray);
    var title = gettextCatalog.getString("RPO Compliance");
    titleList.push(title);

    var result = [ {key: "success", value: data.rto},
        {key: "failure", value: rtoFailure}
    ];
    colorlist.push(pieChartColorMaker(result));
    legends = [gettextCatalog.getString("Success") + " (" + data.rto +  "%)", gettextCatalog.getString("Failure") + " (" + rtoFailure + "%)"];
    legendList.push(legends);
    var successes = data.rto > 0 ? data.rto : MINPERCENT;
    var failures =  data.count === 0 || successes === 100 ? MINPERCENT : 100 - successes;
    var dataArray = [successes, failures];
    dataList.push(dataArray);
    var title = gettextCatalog.getString("RTO Compliance");
    titleList.push(title);

    holderID = $("#flot_holder");

    for (var i =0 ; i <titleList.length ; i++)
    {
        newId = "pie-chart-holder" + i;
        holderID.append('<div id="' + newId + '" style="margin-left:80px;" class="pie-chart-container"></div>');
        createpieChart(newId, titleList[i], dataList[i], colorlist[i], legendList[i]);
    }

}

function createPolicyReportEntry(reportId) {
    return ({
        id:reportId,
        description: gettext("A report showing the jobs and retention for each protected asset."),
        label: gettext("PROTECTION POLICIES"),
        subCatImgClass: "icon-vaultthree icon-large",
        dropDownWithAll: false,
        open:false
    });
}
